* $$ JOB JNM=BSDSERVR,CLASS=A,DISP=D                                            
* $$ LST CLASS=F,DEST=(,AFTPTODS)                                               
// JOB BSDSERVR                                                                 
// OPTION CATAL                                                                 
// LIBDEF *,SEARCH=(DRSLIB.TEST,PRD1.MACLIB),TEMP                               
// LIBDEF *,CATALOG=DRSLIB.TEST                                                 
*                                                                               
* * EXECUTING ASSEMBLY OF SAMPLE BSD SERVER CODE...                             
// EXEC ASMA90,SIZE=ASMA90,PARM='SZ(MAX-200K,ABOVE)'                            
         PUNCH '  PHASE BSDSERVR,*'                                             
BSDBEGIN CSECT                                                                  
*                                                                               
* *                                                                             
* * THIS IS A SAMPLE ASSEMBLER SERVER APPLICATION                               
* * THAT USES THE BSD-C INTERFACE OBJECT DECKS.                                 
* * IT WILL ACCEPT COMMANDS FROM EITHER THE:                                    
* * * VSE SYSTEM CONSOLE                                                        
* * * MICROSOFT VISUAL BASIC SAMPLE ASCII CLIENT APPLICATION                    
* * * SAMCLINT SAMPLE ASSEMBLER EBCIDIC CLIENT APPLICATION                      
* * * THE COMMAND WILL BE EXECUTED AND A RESPONSE SENT TO THE                   
* * * REQUESTOR...                                                              
* *                                                                             
*                                                                               
MAINNAME DC    CL8'BSDSERVR'                                                    
COMVERS  DC    CL8'01.00.00'       VERSION AND RELEASE                          
COMADATE DC    CL8'&SYSDATC'       ASSEMBLED DATE                               
COMATIME DC    CL8'&SYSTIME'       ASSEMBLED TIME                               
         ENTRY IPERRNO                                                          
IPERRNO  DS    F                                                                
         ENTRY IPRETCD                                                          
IPRETCD  DS    F                                                                
@TOASCII DC    A(TOASCII)                                                       
@TOEBCDI DC    A(TOEBCDIC)                                                      
RECBUFFL DC    F'1024'                                                          
SNDBUFFL DC    F'1024'                                                          
@CONORTN DC    A(CONO1000)         CONSOLE OUTPUT ROUTINE                       
@CMNDRTN DC    A(X'80000000'+CMND1000) COMMAND PROCESSOR ROUTINE                
@SAMSRV  DS    A                   @ OF BSDSERVR                                
MAINECB  DC    F'0'                SUBTASK ACCEPT COMPLETED                     
SHUTECB  DC    F'0'                TERMINATE REQUESTED ECB                      
CMNDECB  DC    F'0'                COMMAND ECB                                  
TIMEECB  DC    F'0'                SETIME ECB                                   
DUMMYECB DC    F'0'                DUMMY ECB                                    
MNABRRGS DS    15F                                                              
MNABRETN DC    A(MAIN9000)         MAIN TASK RETURNS HERE                       
PARMS    DS    0F                                                               
PARM1    DS    F                                                                
PARM2    DS    F                                                                
PARM3    DS    F                                                                
PARM4    DS    F                                                                
PARM5    DS    F                                                                
*                                                                               
* * BSD-C PASSED PARAMETER VALUES                                               
BASESOCK DS    F                   SOCKET NUMBER                                
DOMAIN   DC    F'2'                SOCKET.H AF_INET                             
TYPE     DC    F'1'                SOCKET.H SOCK_STREAM                         
PROTOCOL DC    F'2'                SOCKET.H IPPROTO_TCP                         
*                                                                               
SOCKADDR DS    0F                  SOCKET.H struct sockaddr_in                  
         DC    H'2'                SOCKET.H AF_INET                             
SOCKPORT DC    H'6045'             PORT ADDRESS                                 
         DS    F'0'                IP ADDRESS                                   
SOCKADRL DC    F'8'                                                             
*                                                                               
BACKLOG  DC    F'3'                MAXIMUM CONNECTIONS                          
*                                                                               
COMGVSPL DC    CL6'SAMGVS',XL2'0000'                                            
OCEXCMND DS    CL64                OPERATOR COMMAND LINE                        
OCEXCMDL EQU   *-OCEXCMND          LENGTH OF OPERATOR COMMAND LINE              
BLNKLINE DC    CL80' '             A BLANK LINE                                 
COMFLAG1 DC    XL1'00'             COMMON FLAG                                  
MAINSHUT EQU   X'80'               MAIN TASK IS SHUTTING DOWN                   
CARDACTV EQU   X'40'               CARD COMMANDS BEING PROCESSED                
CARDDONE EQU   X'20'               CARD READER COMMANDS DONE                    
INITERR  EQU   X'10'               ERROR OCCURRED DURING INITIALIZATION         
MAINLIST EQU   X'04'               MAIN TASK LISTEN WAS SUCCESSFUL              
         SOCKET ID=00,MF=L         SOCKET GLOBAL CONTANTS                       
CPUID    DS    0D,XL10                                                          
PPID     DC    CL2' '                                                           
PARTMBDY MAPEXTR  ID=BDY,DSECT=NO                                               
SYSTMBDY MAPEXTR  ID=BDY,MODE=SYSP,DSECT=NO,PREFIX=SYS                          
SVAMAP   MAPEXTR  ID=SVA,DSECT=NO,PREFIX=MAP                                    
RETCODE  DC    F'99'                                                            
FWORK    DS    F                                                                
DWORK    DS    D                                                                
CMNDTABL DS    0F                                                               
SHUTDOWN DC    CL8'SHUTDOWN',A(X'80000000'+SHUT1000)                            
SETPORT  DC    CL8'SETPORT ',A(X'80000000'+SETP1000)                            
CALLPROG DC    CL8'CALLPROG',A(X'80000000'+CALP1000)                            
HARTBEAT DC    CL8'HARTBEAT',A(X'80000000'+HART1000)                            
CDLOAD   DC    CL8'CDLOAD  ',A(X'80000000'+CDLD1000)                            
CONTROL  DC    CL8'CONTROL ',A(X'80000000'+CONT1000)                            
ABEND000 DC    CL8'ABEND000',A(0)                                               
CMNDENTL EQU   12                  LENGTH OF A SINGLE TABLE ENTRY               
CMNDTCNT EQU   (*-CMNDTABL)/CMNDENTL NUMBER OF COMMANDS IN TABLE                
STCKSTRT DS    D                                                                
STCKCURR DS    D                                                                
STCKCDAT DS    D                                                                
STCKLDAT DS    D                                                                
STCKDATE DS    0CL10                                                            
STCKCCN  DS    CL2                 CENTURY                                      
STCKCYR  DS    CL2                 YEAR                                         
         DC    C'/'                                                             
STCKCMN  DS    CL2                 MONTH                                        
         DC    C'/'                                                             
STCKCDY  DS    CL2                 DAY                                          
STCKCTIM DS    0CL8                                                             
STCKCHR  DS    CL2                                                              
         DC    C':'                                                             
STCKCMIN DS    CL2                                                              
         DC    C':'                                                             
STCKCSEC DS    CL2                                                              
STCKLTIM DS    CL8                                                              
*                                                                               
TSKTABL  DS    0F                  SUBTASK WORKAREAS                            
@TSK001  DC    A(TSK001)                                                        
@TSK002  DC    A(TSK002)                                                        
@TSK003  DC    A(TSK003)                                                        
TSKTCNT  EQU   (*-TSKTABL)/4                                                    
HRTAB    DS    0F                                                               
         DC    C'23',CL8'ELEVEN'                                                
         DC    C'22',CL8'TEN'                                                   
         DC    C'21',CL8'NINE'                                                  
         DC    C'20',CL8'EIGHT'                                                 
         DC    C'19',CL8'SEVEN'                                                 
         DC    C'18',CL8'SIX'                                                   
         DC    C'17',CL8'FIVE'                                                  
         DC    C'16',CL8'FOUR'                                                  
         DC    C'15',CL8'THREE'                                                 
         DC    C'14',CL8'TWO'                                                   
         DC    C'13',CL8'ONE'                                                   
         DC    C'12',CL8'NOON'                                                  
         DC    C'11',CL8'ELEVEN'                                                
         DC    C'10',CL8'TEN'                                                   
         DC    C'09',CL8'NINE'                                                  
         DC    C'08',CL8'EIGHT'                                                 
         DC    C'07',CL8'SEVEN'                                                 
         DC    C'06',CL8'SIX'                                                   
         DC    C'05',CL8'FIVE'                                                  
         DC    C'04',CL8'FOUR'                                                  
         DC    C'03',CL8'THREE'                                                 
         DC    C'02',CL8'TWO'                                                   
         DC    C'01',CL8'ONE'                                                   
         DC    C'00',CL8'MIDNIGHT'                                              
MNTAB    DS    0F                                                               
         DC    C'01',CL8'JANUARY '                                              
         DC    C'02',CL8'FEBRUARY'                                              
         DC    C'03',CL8'MARCH   '                                              
         DC    C'04',CL8'APRIL   '                                              
         DC    C'05',CL8'MAY     '                                              
         DC    C'06',CL8'JUNE    '                                              
         DC    C'07',CL8'JULY    '                                              
         DC    C'08',CL8'AUGUST  '                                              
         DC    C'09',CL8'SEPTMBER'                                              
         DC    C'10',CL8'OCTOBER '                                              
         DC    C'11',CL8'NOVEMBER'                                              
         DC    C'12',CL8'DECEMBER'                                              
CONOUT   DS    CL64                        OUTPUT BUFFER AREA                   
CONINPUT EQU   CONOUT                      INPUT BUFFER AREA                    
LINEOUT  DS    CL121                                                            
*                                                                               
* * TRANSLATE TABLE DEFINITIONS                                                 
         DC       C'0123456789ABCDEF'                                           
TRTABEN  DS       0X                                                            
         ORG      *-256                                                         
TRTAB    DS       0X                                                            
         ORG      TRTABEN                                                       
*                                                                               
* *      EBCDIC TO ASCII                                                        
*                    0 1 2 3 4 5 6 7 8 9 A B C D E F                            
TOASCII  DC       X'000102030405060708090A0B0C0D0E0F' 00-0F                     
         DC       X'10111213140A161718191A1B1C1D1E1F' 10-1F                     
         DC       X'00000000000000000000000000000000' 20-2F                     
         DC       X'00000000000000000000000000000000' 30-3F                     
         DC       X'200000000000000000005B2E3C282B7C' 40-4F                     
         DC       X'2600000000000000000021242A293B5E' 50-5F                     
         DC       X'2D2F00000000000000007C2C255F3E3F' 60-6F                     
         DC       X'000000000000000000603A2340273D22' 70-7F                     
         DC       X'00616263646566676869008B00000000' 80-8F                     
         DC       X'006A6B6C6D6E6F707172000000000000' 90-9F                     
         DC       X'007E737475767778797A000000000000' A0-AF                     
         DC       X'00000000000000000000000000000000' B0-BF                     
         DC       X'7B414243444546474849000000000000' C0-CF                     
         DC       X'7D4A4B4C4D4E4F505152000000000000' D0-DF                     
         DC       X'5C00535455565758595A000000000000' E0-EF                     
         DC       X'303132333435363738390000000000FF' F0-FF                     
*                                                                               
*        ASCII TO EBCDIC                                                        
*                    0 1 2 3 4 5 6 7 8 9 A B C D E F                            
TOEBCDIC DC       X'000102030405060708090A0B0C0D0E0F' 00-0F                     
         DC       X'101112131415161718191A1B1C1D1E1F' 10-1F                     
         DC       X'405A7F7B5B6C507D4D5D5C4E6B604B61' 20-2F                     
         DC       X'F0F1F2F3F4F5F6F7F8F97A5E4C7E6E6F' 30-3F                     
         DC       X'7CC1C2C3C4C5C6C7C8C9D1D2D3D4D5D6' 40-4F                     
         DC       X'D7D8D9E2E3E4E5E6E7E8E94AE04F5F6D' 50-5F                     
         DC       X'79818283848586878889919293949596' 60-6F                     
         DC       X'979899A2A3A4A5A6A7A8A9C06AD0A100' 70-7F                     
         DC       X'00000000000000000000000000000000' 80-8F                     
         DC       X'00000000000000000000000000000000' 90-9F                     
         DC       X'00000000000000000000000000000000' A0-AF                     
         DC       X'00000000000000000000000000000000' B0-BF                     
         DC       X'00000000000000000000000000000000' C0-CF                     
         DC       X'00000000000000000000000000000000' D0-DF                     
         DC       X'00000000000000000000000000000000' E0-EF                     
         DC       X'000000000000000000000000000000FF' F0-FF                     
*                                                                               
* * THE FOLLOWING ROUNDS OFF SO WE START ON A PAGE BNDRY                        
* * WHICH IS NICE FOR TRACING...                                                
         DS    XL((4096-120-8)-(*-BSDBEGIN))                                    
         DROP  ,                                                                
*                                                                               
         DC    CL8'MAIN1000'                                                    
BSDSERVR CSECT                                                                  
BSDSERVR RMODE 24                                                               
BSDSERVR AMODE 31                                                               
         ENTRY BSDSERVR                                                         
*                                                                               
* * PROGRAM EXECUTION STARTS HERE...                                            
* * WE SHOULD BE ENTERED IN 31-BIT MODE AND WILL GO INTO 24-BIT                 
* * MODE ONLY WHEN USING A SERVICE THAT REQUIRES 24-BIT MODE...                 
MAIN1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R12,R15             SET 1ST BASE REGISTER                        
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         ST    R13,MAINSAVE+4      STORE CALLERS R13                            
         LA    R13,MAINSAVE        PROVIDE SAVEAREA                             
         L     R9,=A(BSDBEGIN)     @ OF MAINTASK COMMON AREA                    
         USING BSDBEGIN,R9                                                      
         AMODESW SET,AMODE=24      SWITCH TO 24 BIT MODE FOR OPENS              
         OPEN  CONSOLE,LISTING                                                  
         AMODESW SET,AMODE=31      SWITCH BACK TO 31-BIT MODE                   
         SLR   R8,R8               CLEAR TASK WORK AREA POINTER                 
         ST    R12,@SAMSRV         STORE OUR ADDRESS                            
         UNPK  BIGWORK1(9),@SAMSRV(5) UNPACK                                    
         TR    BIGWORK1(8),TRTAB    TRANSLATE TO HEX                            
         MVC   INITADDR,BIGWORK1   MOVE INTO THE MESSAGE                        
         LA    R0,INITMSGL                                                      
         LA    R1,INITMSG                                                       
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         EXTRACT  ID=CPUID,AREA=CPUID,LEN=10                                    
         EXTRACT  ID=BDY,AREA=SYSTMBDY,LEN=SYSSYLEN                             
         EXTRACT  ID=SVA,AREA=SVAMAP,LEN=MAPSVALN                               
         L     R2,20               @ OF ACTIVCE COMREG                          
         USING COMREG,R2                                                        
         MVC   PPID,PID            GET OUR PIK                                  
         EXTRACT  ID=PART,AREA=PARTMBDY,LEN=MBDYLEN,PID=PPID                    
         DROP  R2                                                               
         L     R0,=A(MNAB1000)     ABEND EXIT ROUTINE                           
         L     R1,=A(MNABSAV1)     ABEND SAVE AREA                              
         STXIT AB,(0),(1),AMODE=ANY,OPTION=NODUMP                               
         STM   R0,R14,MNABRRGS     STORE REGS IN CASE OF ABEND                  
         BAL   R2,TRACEIT                                                       
         DC    CL8'MAIN1000'                                                    
MAIN1400 DS    0H                                                               
         LA    R2,TSKTABL          @ OF SUBTASK WORKAREAS                       
         LA    R3,TSKTCNT          NUMBER OF SUBTASKS IN THE TABLE              
         LA    R5,1                NAMED STARTING WITH ONE                      
*                                                                               
* * FIRST LETS GO AHEAD AND ATTACH THE VSE SUBTASKS...                          
MAIN1500 DS    0H                                                               
         L     R8,0(R2)            @ OF THE TASK WORK AREA                      
         USING TSKWORK,R8          TO USE DURING CARD1000                       
         L     R0,SNDBUFFL         GET THIS MUCH STORAGE                        
         GETVIS SPID=COMGVSPL                                                   
         LTR   R15,R15             DID IT WORK                                  
         BZ    MAIN1700            BIF YES                                      
         BAL   R1,MAIN7000         EXIT WITH ERROR REASON                       
         DC    CL8'GETVIS02'                                                    
MAIN1700 DS    0H                                                               
         ST    R1,TSK@SEND         STORE SEND BUFFER ADDRESS                    
         CVD   R5,DWORK            USE THIS FOR THE TASK NAME                   
         UNPK  FWORK(3),DWORK+6(2) UNPACK IT TO PRINTABLE                       
         OI    FWORK+2,X'F0'       MAKE THE SIGN RIGHT                          
         MVC   TSKSAVAR+0(6),=C'SAMSRV'                                         
         MVC   TSKSAVAR+6(2),FWORK+1 SUBTASK NAME                               
         L     R11,=A(TASK1000)    ENTRY POINT                                  
         ATTACH (R11),             ATTACH A VSE SUBTASK                X        
               SAVE=(S,TSKSAVAR),  VSE TASK SAVE AREA                  X        
               ECB=(S,TSKTECB)     POST THIS ECB WHEN THIS TASK ENDS            
         LTR   R1,R1               DID IT WORK?                                 
         BP    MAIN1800            BIF YES                                      
         BAL   R1,MAIN7000         EXIT WITH ERROR REASON                       
         DC    CL8'ATTFAILD'                                                    
MAIN1800 DS    0H                                                               
         OI    TSKFLAG1,TSKATTCH   FLAG TASK AS ATTACHED                        
         LA    R5,1(,R5)           ADD ONE HERE TOO                             
         LA    R2,4(,R2)           BUMP TO THE NEXT TASK                        
         BCT   R3,MAIN1500         DO IT AGAIN                                  
*                                                                               
         LA    R1,MAINECB          MAINTASK ECB FOR SUBTASKS TO POST            
         ST    R1,@MAINECB         STORE IT                                     
         LA    R1,CMNDECB          COMMON TERMINATE ECB                         
         ST    R1,@CMNDECB         STORE IT                                     
         LA    R1,TIMEECB          TIMER ECB                                    
         ST    R1,@TIMEECB         STORE IT                                     
         LA    R1,SHUTECB          COMMON TERMINATE ECB                         
         ST    R1,@SHUTECB         STORE IT                                     
         LA    R1,DUMMYECB         DUMMY ECB LAST IN THE LIST                   
         ST    R1,@DUMBECB         STORE IT                                     
         OI    @DUMBECB,X'80'      FLAG AS LAST ECB IN THE LIST                 
         L     R15,=A(CARD1000)    READ COMMANDS FROM SYSRDR                    
         BASSM R14,R15                                                          
MAIN1900 DS    0H                                                               
         L     R0,=A(OCEX1000)     OPERATOR COMMUNICATION EXIT RTN              
         L     R1,=A(OCEXSAV1)     OC EXIT SAVE AREA                            
         STXIT OC,(0),(1),MSGDATA=YES,AMODE=ANY                                 
         MVI      TIMEECB+2,X'80'  POST THE TIMER ECB                           
*                                                                               
* * NOW STARTS THE MAIN LOOP OF WAITING FOR SOMETHING TO DO                     
* * SINCE WE ALREADY HAVE THE TASKS ATTACHED WE SET IT UP SO                    
* * AS SOON AS SOMETHING COMES IN WE HAVE A SUBTASK SITTING ON AN               
* * ACCEPT WHICH IS A WAIT ON THE PASSIVE ECB...                                
MAIN2000 DS       0H                                                            
*                                                                               
* * FIND A FREE SUBTASK...                                                      
         LA    R2,TSKTABL          @ OF SUBTASK WORKAREAS                       
         LA    R3,TSKTCNT          NUMBER OF SUBTASKS IN THE TABLE              
MAIN2100 DS    0H                                                               
         L     R8,0(R2)            @ OF THE TASK WORK AREA                      
         USING TSKWORK,R8                                                       
         TM    TSKFLAG1,TSKINUSE   IS IT IN USE?                                
         BO    MAIN2110            BIF YES SKIP IT                              
         TM    TSKFLAG1,TSKATTCH   IS IT ATTACHED?                              
         BO    MAIN2180            BIF YES USE IT                               
MAIN2110 DS    0H                                                               
         LA    R2,4(,R2)           BUMP TO THE NEXT TASK                        
         BCT   R3,MAIN2100         TRY AGAIN                                    
         BAL   R1,MAIN7000         EXIT WITH ERROR REASON                       
         DC    CL8'NOSUBTSK'                                                    
MAIN2180 DS    0H                                                               
         ST    R8,@TSKWORK         STORE THE CURRENT TASK WORK                  
         OI    TSKFLAG1,TSKINUSE   FLAG TASK AS IN USE                          
         TM    COMFLAG1,MAINLIST   DID WE ALREADY DO THE LISTEN ?               
         BO    MAIN2196            BIF YES POST A SUBTASK TO ACCEPT..           
*                                                                               
* * BSD-C SOCKET() CALL INVOKES IPNRSOCK...                                     
         LA    R1,DOMAIN           @ OF DOMAIN                                  
         ST    R1,PARM1            STORE IT                                     
         LA    R1,TYPE             @ OF TYPE                                    
         ST    R1,PARM2            STORE IT                                     
         LA    R1,PROTOCOL         @ OF PROTOCOL                                
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRSOCK)    @ SOCKET FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID WE GET A SOCKET NUMBER ?                 
         BNM   MAIN2192            BIF YES                                      
         BAL   R1,MAIN7600         BSDC FUNCTION FAILED                         
         DC    C'IPNRSOCK'                                                      
MAIN2192 DS    0H                                                               
         ST    R15,BASESOCK        STORE THE SOCKET NUMBER                      
*                                                                               
* * BSD-C BIND() CALL INVOKES IPNRBIND...                                       
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         LA    R1,SOCKADDR         @ OF SOCKADDR_IN STRUCTURE                   
         ST    R1,PARM2            STORE IT                                     
         LA    R1,SOCKADRL         @ OF LENGTH OF STRUCTURE                     
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRBIND)    @ BIND FUNCTION ROUTINE                      
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID WE BIND TO THE PORT ?                    
         BNM   MAIN2194            BIF YES                                      
         BAL   R1,MAIN7600         BSDC FUNCTION FAILED                         
         DC    C'IPNRBIND'                                                      
MAIN2194 DS    0H                                                               
*                                                                               
* * BSD-C LISTEN() CALL INVOKES IPNRLIST...                                     
* * THIS WILL CAUSE A PASSIVE OPEN TO BE ISSUED...                              
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         LA    R1,BACKLOG          @ MAXIMUM CONNECTIONS                        
         ST    R1,PARM2            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRLIST)    @ LISTEN FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE LISTEN WORK ?                        
         BNM   MAIN2195            BIF YES                                      
         BAL   R1,MAIN7600         BSDC FUNCTION FAILED                         
         DC    C'IPNRLIST'                                                      
MAIN2195 DS    0H                                                               
         OI    COMFLAG1,MAINLIST   FLAG AS INITIAL LISTEN DONE                  
MAIN2196 DS    0H                                                               
         LA    R1,TSKECB1          POST THIS ECB                                
         LA    R0,TSKSAVAR         OF THIS SUBTASK                              
         POST  (1),(0)             MAKE VSE SUBTASK READY TO RUN                
MAIN3000 DS    0H                                                               
         LA    R1,MAINWLST         ECB LIST TO WAIT ON                          
         WAITM (1)                 WAIT FOR SOMETHING TO HAPPEN                 
         STCK  STCKCURR            STORE THE CURRENT TIME                       
         C     R1,@SHUTECB         SHOULD WE TERMINATE                          
         BE    MAIN8000            BIF YES                                      
         XC    0(4,R1),0(R1)       CLEAR THE POSTED ECB                         
         C     R1,@MAINECB         DID A SUBTASK ACCEPT A CONNECTION ?          
         BE    MAIN4000            BIF YES                                      
         C     R1,@CMNDECB         WAS THERE A COMMAND TO PROCESS?              
         BE    MAIN5000            BIF YES                                      
         C     R1,@TIMEECB         DID SETIME EXPIRE?                           
         BE    MAIN6000            BIF YES                                      
         BAL   R1,MAIN7000         EXIT WITH ERROR REASON                       
         DC    C'BADMECB'                                                       
*                                                                               
* * THE SUBTASK HAD A CONNECTION SO LETS FIND A NEW SUBTASK                     
* * TO LISTEN ON BASESOCK...                                                    
MAIN4000 DS    0H                                                               
         L     R1,CONNECTD         COUNTER OF CONNECTS PROCESSED                
         LA    R1,1(,R1)           PLUS 1 MORE                                  
         ST    R1,CONNECTD         STORE UPDATED COUNTER OF CONNECTS            
         B     MAIN2000            FIND A NEW SUBTASK FOR NEXT CONNTN           
CONNECTD DC    F'0'                NUMBER OF CONNECTIONS                        
*                                                                               
MAIN5000 DS    0H                                                               
         LA    R0,OCEXCMDL                                                      
         LA    R1,OCEXCMND         @ OF OPERATOR COMMAND                        
         L     R15,@CMNDRTN        CALL THE COMMAND PROCESSOR                   
         BASSM R14,R15                                                          
*                                                                               
* * ALL COMMANDS GIVE A RESPONSE SO LETS DISPLAY IT ON THE CONSOLE              
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     MAIN3000            GO REISSUE THE WAITM                         
*                                                                               
MAIN6000 DS    0H                                                               
         COMRG R2                                                               
         USING COMREG,R2                                                        
         LM    R0,R1,STCKCURR      GET THE CURRENT TIME                         
         GETIME STANDARD,LOCAL,CLOCK=YES                                        
         ST    R1,FWORK                                                         
         STM   R14,R15,STCKCDAT    STORE THE CURRENT DATE                       
         TM    LTACT,DDMMYY        IS THIS EUROPEAN DATE FORMAT?                
         BO    MAIN6020            BIF YES                                      
         MVC   STCKCMN,STCKCDAT+0  MONTH                                        
         MVC   STCKCDY,STCKCDAT+2  DAY                                          
         B     MAIN6030                                                         
MAIN6020 DS    0H                                                               
         MVC   STCKCDY,STCKCDAT+0  DAY                                          
         MVC   STCKCMN,STCKCDAT+2  MONTH                                        
MAIN6030 DS    0H                                                               
         MVC   STCKCYR,STCKCDAT+4  YEAR                                         
         MVC   STCKCCN,STCKCDAT+6  CENTURY                                      
         DROP  R2                                                               
         UNPK  DWORK,FWORK         UNPACK                                       
         OI    DWORK+7,X'F0'       FIX THE SIGN                                 
         MVC   STCKCHR,DWORK+2                                                  
         MVC   STCKCMIN,DWORK+4                                                 
         MVC   STCKCSEC,DWORK+6                                                 
         CLC   STCKCDAT,STCKLDAT           IS IT A NEW DAY?                     
         BNE   MAIN6100                    BIF YES                              
         CLC   STCKCMIN,STCKLTIM+3         IS IT A NEW MINUTE?                  
         BNE   MAIN6300                    BIF YES                              
         LA    R0,L'TIMEECBX                                                    
         LA    R1,TIMEECBX         MESSAGE                                      
         L     R15,@CONORTN                                                     
*         BASSM R14,R15                                                         
         B     MAIN6800            EXIT                                         
TIMEECBX DC    CL8'TIMEECBX'                                                    
MAIN6100 DS    0H                                                               
         ICM   R0,15,STCKSTRT      IS THIS THE FIRST TIME EVER?                 
         BNZ   MAIN6120            BIF NO                                       
         MVC   DATEFDAT,STCKDATE   MOVE IN THE DATE                             
         LA    R0,DATEFRSL         MESSAGE LENGTH                               
         LA    R1,DATEFRST         MESSAGE                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         MVC   STCKSTRT,STCKCURR   SAVE THE START UP STORE CLOCK                
         B     MAIN6180            ALL SET                                      
MAIN6120 DS    0H                                                               
         LA    R15,12              LOOP                                         
         LA    R14,MNTAB           @ TABLE OF MONTHS                            
MAIN6130 DS    0H                                                               
         CLC   0(2,R14),STCKCMN    IS IT A HIT                                  
         BE    MAIN6140            BIF YES                                      
         LA    R14,10(,R14)        BUMP                                         
         BCT   R15,MAIN6130        LOOP                                         
MAIN6140 DS    0H                                                               
         MVC   DATENMON,2(R14)      MOVE IN MONTH AS A WORD                     
         MVC   DATENDY,STCKCDY      MOVE IN DAY                                 
         MVC   DATENCN,STCKCCN      MOVE IN CENTURY                             
         MVC   DATENYR,STCKCYR      MOVE IN YEAR                                
         LA    R0,DATENDAL         MESSAGE LENGTH                               
         LA    R1,DATENDAY         MESSAGE                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
MAIN6180 DS    0H                                                               
         MVC   STCKLDAT,STCKCDAT   SET UP FOR NEXT TIME                         
         B     MAIN6800            EXIT                                         
MAIN6300 DS    0H                                                               
         CLC   STCKCMIN,=C'00'     IS IT THIS                                   
         BE    MAIN6360            BIF YES                                      
         CLC   STCKCMIN,=C'15'     IS IT THIS                                   
         BE    MAIN6315            BIF YES                                      
         CLC   STCKCMIN,=C'30'     IS IT THIS                                   
         BE    MAIN6330            BIF YES                                      
         CLC   STCKCMIN,=C'45'     IS IT THIS                                   
         BE    MAIN6345            BIF YES                                      
         MVC   TIMEMNMT,STCKCTIM   MOVE IN TIME IT IS NOW                       
         LA    R0,TIMEMNML         MESSAGE LENGTH                               
         LA    R1,TIMEMNMN         MESSAGE                                      
         L     R15,@CONORTN                                                     
*         BASSM R14,R15                                                         
         B     MAIN6800            EXIT                                         
MAIN6315 DS    0H                                                               
         LA    R0,TIMEQAFL         MESSAGE LENGTH                               
         LA    R1,TIMEQAFH         MESSAGE                                      
         LA    R2,TIMEQAHR         PUT HOUR HERE                                
         B     MAIN6380            ISSUE NICE MESSAGE                           
MAIN6330 DS    0H                                                               
         LA    R0,TIMEHAFL         MESSAGE LENGTH                               
         LA    R1,TIMEHAFH         MESSAGE                                      
         LA    R2,TIMEHAHR         PUT HOUR HERE                                
         B     MAIN6380            ISSUE NICE MESSAGE                           
MAIN6345 DS    0H                                                               
         LA    R0,TIMEQTLL         MESSAGE LENGTH                               
         LA    R1,TIMEQTLH         @ MESSAGE                                    
         LA    R2,TIMEQTHR         PUT HOUR HERE                                
         B     MAIN6380            ISSUE NICE MESSAGE                           
MAIN6360 DS    0H                                                               
         LA    R0,TIMENHRL         MESSAGE LENGTH                               
         LA    R1,TIMENHRM         MESSAGE                                      
         LA    R2,TIMENHRH         PUT HOUR HERE                                
MAIN6380 DS    0H                                                               
         LA    R15,24              LOOP                                         
         LA    R14,HRTAB           @ TABLE OF HOURS                             
MAIN6382 DS    0H                                                               
         CLC   0(2,R14),STCKCHR    IS IT A HIT                                  
         BE    MAIN6384            BIF YES                                      
         LA    R14,10(,R14)        BUMP                                         
         BCT   R15,MAIN6382        LOOP                                         
MAIN6384 DS    0H                                                               
         MVC   0(8,R2),2(R14)      MOVE IN HOUR AS A WORD                       
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
MAIN6800 DS    0H                                                               
         MVC   STCKLTIM,STCKCTIM   SET UP FOR NEXT TIME                         
         LA    R2,TIMEECB          @ SETIME ECB                                 
         LA    R1,30               WAKE UP EVERY 30 SECONDS                     
         SETIME (1),(2)            SET THE TIMER                                
         B     MAIN3000            REISSUE THE WAITM                            
*                                                                               
MAIN7000 DS    0H                                                               
         LTR   R15,R15             WAS A RETURN CODE PASSED                     
         BNZ   MAIN7200            BIF YES                                      
         LA    R15,8               SET BAD RETURN CODE                          
MAIN7200 DS    0H                                                               
         ST    R15,RETCODE         STORE IT                                     
         MVC   IERRRESN,0(R1)      ERROR MESSAGE REASON                         
         LA    R0,IERRMSGL         ERROR MESSAGE LENGTH                         
         LA    R1,IERRMSG          ERROR MESSAGE TEXT                           
         L     R15,@CONORTN                                                     
         BASSM R14,R15             WRITE ERROR REASON ONTO SYSLST               
         B     MAIN9000            EXIT                                         
*                                                                               
MAIN7600 DS    0H                                                               
         LA    R15,9                                                            
         ST    R15,RETCODE         STORE IT                                     
         MVC   BSDCNAME,0(R1)      NAME OF PROGRAM                              
         UNPK  BIGWORK1(9),IPERRNO(5) UNPACK                                    
         TR    BIGWORK1(8),TRTAB    TRANSLATE TO HEX                            
         MVC   BSDCRETC,BIGWORK1   MOVE INTO THE MESSAGE                        
         UNPK  BIGWORK1(9),IPRETCD(5) UNPACK                                    
         TR    BIGWORK1(8),TRTAB    TRANSLATE TO HEX                            
         MVC   BSDCERRC,BIGWORK1   MOVE INTO THE MESSAGE                        
         LA    R0,BSDCEMSL         MESSAGE LENGTH                               
         LA    R1,BSDCEMSG         MESSAGE TEXT                                 
         L     R15,@CONORTN                                                     
         BASSM R14,R15             WRITE ERROR REASON ONTO SYSLST               
         B     MAIN9000            EXIT                                         
*                                                                               
MAIN8000 DS    0H                                                               
         LA    R2,TIMEECB          @ SETIME ECB                                 
         LA    R1,3                WAIT FOR THIS MANY SECONDS                   
         SETIME (1),(2)            SET THE TIMER                                
         LA    R1,TIMEECB          WAIT FOR THE SUBTASKS TO TERMINATE           
         WAIT  (1)                                                              
         LA    R15,0               RETURN CODE IS ZERO                          
         ST    R15,RETCODE         STORE THE RETURN CODE                        
MAIN9000 DS    0H                                                               
         LA    R15,MAIN9900        IF ABEND OCCURS RESTART HERE                 
         ST    R15,MNABRETN        STORE IT FOR STXIT AB EXIT                   
         TM    COMFLAG1,CARDDONE   DID WE READ THE CARD COMMANDS                
         BO    MAIN9200            BIF YES                                      
         OI    COMFLAG1,INITERR    ERROR MUST HAVE OCCURRED DURING INIT         
         L     R15,=A(CARD1000)    FLUSH SYSRDR                                 
         BASSM R14,R15                                                          
MAIN9200 DS    0H                                                               
         LA    R0,L'SHUTMSG                                                     
         LA    R1,SHUTMSG                                                       
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
MAIN9900 DS    0H                                                               
*                                                                               
* * THE FOLLOWING IS THE SAME AS DOING AN EOJ MACRO...                          
         L     R15,RETCODE         RETURN CODE                                  
         L     R13,MAINSAVE+4      RESTORE JOB CONTROLS R13                     
         LM    R0,R12,20(R13)      RESTORE R0-R12                               
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
*                                                                               
* *                                                                             
TRACEIT  DS    0H                                                               
         LA    R0,8                                                             
         LTR   R1,R2               @ OF TRACE INFO                              
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     8(R2)               RETURN                                       
*                                                                               
MAINSAVE DS    9D                                                               
MAINWLST DS    0F                  MAINTASK WAITM ECB LIST                      
@MAINECB DS    F                                                                
@CMNDECB DS    F                                                                
@SHUTECB DS    F                                                                
@TIMEECB DS    F                                                                
@DUMBECB DS    F                                                                
@TSKWORK DS    F                                                                
BIGWORK1 DS    XL256               BIG WORK AREA                                
*                                                                               
INITMSG  DC    C'BSDSERVR='                                                     
INITADDR DC    CL8'X'                                                           
INITMSGL EQU   *-INITMSG                                                        
*                                                                               
IERRMSG  DS    0H                                                               
         DC    C'Critical Error Occurred Reason='                               
IERRRESN DC    CL8'XXXXXXXX'                                                    
IERRMSGL EQU   *-IERRMSG                                                        
*                                                                               
BSDCEMSG DS    0H                                                               
BSDCNAME DS    CL8                                                              
         DC    C' RETCD='                                                       
BSDCRETC DC    CL8'XXXXXXXX'                                                    
         DC    C' ERRCD='                                                       
BSDCERRC DC    CL8'XXXXXXXX'                                                    
BSDCEMSL EQU   *-BSDCEMSG                                                       
*                                                                               
SHUTMSG  DC    C'SHUTDOWN COMPLETE'                                             
*                                                                               
DATEFRST DS    0H                                                               
         DC    C'STARTUP COMPLETE '                                             
DATEFDAT DC    CL10'X'                                                          
DATEFRSL EQU   *-DATEFRST                                                       
*                                                                               
DATENDAY DS    0H                                                               
         DC    C'IT''S A NEW DAY '                                              
DATENMON DC    CL8'X'                                                           
         DC    C' '                                                             
DATENDY  DC    CL2'X'                                                           
         DC    C', '                                                            
DATENCN  DC    CL2'X'                                                           
DATENYR  DC    CL2'X'                                                           
DATENDAL EQU   *-DATENDAY                                                       
*                                                                               
TIMENHRM DS    0H                                                               
         DC    C'IT IS NOW '                                                    
TIMENHRH DC    CL8' '                                                           
         DC    C'O''CLOCK'                                                      
TIMENHRL EQU   *-TIMENHRM                                                       
*                                                                               
TIMEMNMN DS    0H                                                               
         DC    C'NEW MINUTE AT '                                                
TIMEMNMT DC    CL8' '                                                           
TIMEMNML EQU   *-TIMEMNMN                                                       
*                                                                               
TIMEQAFH DS    0H                                                               
         DC    C'IT''S A QUARTER AFTER '                                        
TIMEQAHR DC    CL8' '                                                           
TIMEQAFL EQU   *-TIMEQAFH                                                       
*                                                                               
TIMEHAFH DS    0H                                                               
         DC    C'IT''S HALF PAST '                                              
TIMEHAHR DC    CL8' '                                                           
TIMEHAFL EQU   *-TIMEHAFH                                                       
*                                                                               
TIMEQTLH DS    0H                                                               
         DC    C'IT''S 45 AFTER '                                               
TIMEQTHR DC    CL8' '                                                           
TIMEQTLL EQU   *-TIMEQTLH                                                       
         LTORG ,                                                                
*                                                                               
CONSOLE  DTFCN DEVADDR=SYSLOG,             CONSOLE DEVICE ADDRESS      *        
               IOAREA1=CONOUT,             I/O AREA BUFFERS OUT+IN     *        
               RECFORM=FIXUNB,             FIXED UNBLOCKED             *        
               BLKSIZE=64,                 OUTPUT AREA SIZE            *        
               INPSIZE=64,                 INPUT AREA SIZE             *        
               TYPEFLE=CMBND               COMBINED INPUT/OUTPUT                
*                                                                               
LISTING  DTFDI    DEVADDR=SYSLST,          DEFINE A PRINTER            *        
               IOAREA1=LINEOUT,            OUTPUT LINE                 *        
               RECSIZE=121                 LENGTH OF RECORD                     
*                                                                               
         LTORG ,                                                                
         DS    0D                                                               
         DS    XL(8192-(*-BSDSERVR))                                            
*                                                                               
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING TASK1000,R11                                                     
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'TASK1000'       CORE MARKER                                  
TASK1000 DS    0D                                                               
*                                                                               
* * AFTER THE MAIN TASK ATTACHES A SUBTASK                                      
* * THE FOLLOWING CODE GETS CONTROL...                                          
         LA    R13,TSKSAV01        SAVE AREA FOR CALLING ROUTINES               
         ASYSCOM R2                                                             
         USING SYSCOM,R2                                                        
         MVC   TSKTID,IJBTIK       SAVE THE VSE TASK ID                         
         DROP  R2                                                               
         BAL   R2,TRACEIT                                                       
         DC    CL8'TASK1000'                                                    
         LA    R1,TSKECB1          @ OF ECB                                     
         ST    R1,@TSKECB1                                                      
         LA    R1,SHUTECB          @ OF COMMON TERMINATION ECB                  
         ST    R1,@TSKECB2                                                      
         LA    R1,DUMMYECB         @ OF DUMMY ECB                               
         ST    R1,@TSKECB3                                                      
         OI    @TSKECB3,X'80'      FLAG AS LAST ECB IN THE LIST                 
TASK2000 DS    0H                                                               
*                                                                               
* * NOW WAIT FOR MAINTASK TO POST US WITH SOMETHING TO DO...                    
         LA    R1,TSKWAITM         @ OF LIST OF ECBS TO WAIT ON                 
         WAITM (1)                 WAIT FOR SOMETHING TO HAPPEN                 
         C     R1,@TSKECB2         TERMINATE POSTED ?                           
         BE    TASK9000            BIF YES                                      
         C     R1,@TSKECB1         IS THIS ECB1 POSTED ?                        
         BE    TASK2100            BIF YES                                      
         DC    H'0'                NEVER SHOULD OCCURR...                       
TASK2100 DS    0H                                                               
         XC    TSKECB1,TSKECB1     CLEAR THE POSTED ECB                         
         LA    R1,IBUFFERL         LENGTH OF STRUCTURE                          
         ST    R1,TSKFWRK1         STORE IT HERE                                
*                                                                               
* * THE MAINTASK HAS POSTED US SO LETS ISSUE A ACCEPT.                          
* * THE ACCEPT WILL ISSUE A VSE WAIT...BSD-C CALLS THIS BLOCKING.               
* * SO THE SUBTASK WILL BE IN A WAIT UNTIL A SOMEONE CONNECTS TO IT...          
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,TSKPARMS+0       STORE IT                                     
         LA    R1,IBUFFER          @ OF SOCKADDR_IN STRUCTURE                   
         ST    R1,TSKPARMS+4       STORE IT                                     
         LA    R1,TSKFWRK1         @ OF LENGTH                                  
         ST    R1,TSKPARMS+8       STORE IT                                     
         LA    R1,TSKPARMS         @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRACCP)    @ ACCEPT FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE ACCEPT WORK ?                        
         BNM   TASK2200            BIF YES                                      
         LA    R0,L'ACCPTERM                                                    
         LA    R1,ACCPTERM                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     TASK6000            CLOSE THIS CONNECTION NOW                    
ACCPTERM DC    C'ACCEPT TERMINATED'                                             
TASK2200 DS    0H                                                               
         ST    R15,TSKSOCKN        STORE THE NEW SOCKET NUMBER                  
         OI    TSKFLAG1,TSKCONNX   FLAG TASK AS CONNNECTED                      
         LA    R1,MAINECB          POST THE MAINTASK ECB                        
         POST  (1)                 MAKE VSE MAINTASK READY TO RUN               
*                                                                               
* * GET A COMMAND FROM THE TCP STREAM...                                        
TASK3000 DS    0H                                                               
         BAL   R2,TRACEIT                                                       
         DC    CL8'TASK3000'                                                    
         XC    TSKCMND,TSKCMND     CLEAR AREA TO BINARY ZEROS                   
         LA    R0,L'TSKCMND        MAXIMUM COMMAND LENGTH                       
         LA    R1,TSKCMND          BUILD THE COMMAND HERE                       
         L     R15,=A(RSTR1000)    @ OF THE STREAM READ ROUTINE                 
         BALR  R14,R15                                                          
         LTR   R15,R15             DID WE GET A COMMAND ?                       
         BZ    TASK3200            BIF YES                                      
         LA    R0,L'RECVTERM                                                    
         LA    R1,RECVTERM                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     TASK6000            CLOSE THE CONNECTION NOW                     
RECVTERM DC    C'RECEIVE TERMINATED'                                            
TASK3200 DS    0H                                                               
         LTR   R2,R0               LENGTH OF COMMAND DATA                       
         BP    TASK3300            BIF YES                                      
         DC    H'0'                SHOULD NEVER OCCUR                           
TASK3300 DS    0H                                                               
         ST    R2,TSKCMNDL         STORE THE ACTUAL LENGTH                      
         TM    TSKFLAG1,TSKASCII   IS IT AN ASCII COMMAND ?                     
         BNO   TASK3400            BIF NO                                       
         BCTR  R2,0                MINUS 1                                      
         EX    R2,TASKEBCD         TRANSLATE DATA TO EBCIDIC                    
         LA    R2,1(,R2)           PUT LENGTH BACK TO ORIGINAL                  
TASK3400 DS    0H                                                               
         L     R0,TSKCMNDL         LENGTH OF COMMAND TO PROCESS                 
         LA    R1,TSKCMND          PROCESS THIS COMMAND                         
         L     R15,@CONORTN        DISPLAY COMMON ON SYSLST + SYSLOG            
         BASSM R14,R15                                                          
         L     R0,TSKCMNDL         LENGTH OF COMMAND TO PROCESS                 
         LA    R1,TSKCMND          PROCESS THIS COMMAND                         
         L     R15,@CMNDRTN        @ OF THE COMMAND PROCESSOR                   
         BASSM R14,R15             CALL IT                                      
         L     R3,TSK@SEND         BUILD RESPONSE HERE                          
         LTR   R15,R15             DID THE COMMAND SUCCEED?                     
         BZ    TASK4000            BIF YES                                      
         MVC   0(4,R3),=C'FAIL'    COMMAND FAILED                               
         B     TASK4800            FILL IN THE REASON                           
TASK4000 DS    0H                                                               
         MVC   0(4,R3),=C'GOOD'    COMMAND WAS GOOD                             
TASK4800 DS    0H                                                               
         LA    R3,4(,R3)           BUMP SEND BUFFER POINTER                     
         LTR   R2,R0               LENGTH OF DATA TO SEND BACK?                 
         BZ    TASK5000            BIF NONE                                     
         BCTR  R2,0                MINUS 1 FOR MVC                              
         EX    R2,TASKMVCS         MOVE REPLY DATA INTO SEND BUFFER             
         LA    R3,1(R2,R3)         BUMP TO END                                  
TASK5000 DS    0H                                                               
         L     R1,TSK@SEND         START OF SEND BUFFER                         
         MVC   0(4,R3),0(R1)       MOVE IN A BOOKEND                            
         MVI   4(R3),EBCEOL        EBCIDIC END OF LINE CHARARACTER              
         LA    R2,5(,R3)           END OF SEND BUFFER                           
         SLR   R2,R1               CALCULATE LENGTH OF DATA TO BE SENT          
         ST    R2,TSKSENDL         STORE IT                                     
         L     R0,TSKSENDL         LENGTH OF COMMAND TO PROCESS                 
         L     R1,TSK@SEND         PROCESS THIS COMMAND                         
         L     R15,@CONORTN        DISPLAY COMMON ON SYSLST + SYSLOG            
         BASSM R14,R15                                                          
         TM    TSKFLAG1,TSKASCII   IS THE CLIENT ASCII ?                        
         BNO   TASK5100            BIF NO                                       
         BCTR  R2,0                MINUS 1                                      
         EX    R2,TASKASCI         TRANSLATE DATA TO ASCII                      
TASK5100 DS    0H                                                               
*                                                                               
* * BSD-C SEND FUNCTION CALL...                                                 
         LA    R1,TSKSOCKN         @ OF SOCKET NUMBER                           
         ST    R1,TSKPARMS+0       STORE IT                                     
         L     R1,TSK@SEND         @ OF DATA TO SEND                            
         ST    R1,TSKPARMS+4       STORE IT                                     
         LA    R1,TSKSENDL         @ OF SEND LENGTH                             
         ST    R1,TSKPARMS+8       STORE IT                                     
         LA    R1,TSKPARMS         @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRSEND)    @ ACCEPT FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE DATA GET SENT ?                      
         BNM   TASK5200            BIF YES                                      
         DC    H'0'                NEVER SHOULD OCCURR...                       
TASK5200 DS    0H                                                               
         XC    SESRWLNG,SESRWLNG                                                
         XC    SESRWADR,SESRWADR                                                
         B     TASK3000            GO WAIT FOR ANOTHER COMMAND                  
*                                                                               
* * CLOSE THE CONNECTION                                                        
TASK6000 DS    0H                                                               
         LA    R0,L'SESSCLOS                                                    
         LA    R1,SESSCLOS                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     TASK6100                                                         
SESSCLOS DC    C'SESSION CLOSED'                                                
TASK6100 DS    0H                                                               
*                                                                               
* * BSD-C CLOSE FUNCTION CALL...                                                
         LA    R1,TSKSOCKN         @ OF SOCKET NUMBER                           
         ST    R1,TSKPARMS+0       STORE IT                                     
         LA    R1,TSKPARMS         @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRCLOS)    @ CLOSE FUNCTION ROUTINE                     
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE SOCKET GET CLOSED ?                  
         BNM   TASK6200            BIF YES                                      
         LA    R0,L'CLOSTERM                                                    
         LA    R1,CLOSTERM                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     TASK6200            IGNORE THE ERROR                             
CLOSTERM DC    C'CLOSE TERMINATED'                                              
TASK6200 DS    0H                                                               
         NI    TSKFLAG1,X'FF'-TSKINUSE FLAG AS NO LONGER IN USE                 
         NI    TSKFLAG1,X'FF'-TSKCONNX FLAG AS NO LONGER CONNECTED              
         XC    SESRWLNG,SESRWLNG                                                
         XC    SESRWADR,SESRWADR                                                
         B     TASK2000            GO WAIT FOR MORE WORK                        
TASK9000 DS    0H                                                               
         LA    R0,L'TASKTERM                                                    
         LA    R1,TASKTERM                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         DETACH   ,                                                             
TASKTERM DC    CL8'TASKTERM'                                                    
TASKMVCS MVC   0(0,R3),0(R1)       EXECUTED INSTRUCTION                         
TASKEBCD TR    TSKCMND(0),TOEBCDIC EXECUTED INSTRUCTION                         
TASKASCI TR    0(0,R1),TOASCII     TRANSLATE TO ASCII                           
         LTORG ,                                                                
         DS    XL(4088-(*-TASK1000))                                            
         DROP  ,                                                                
*                                                                               
TSK001   DS    XL4096                                                           
TSK002   DS    XL4096                                                           
TSK003   DS    XL4096                                                           
SESFIRST DS    XL4096                                                           
*                                                                               
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'RSTR1000'                                                    
RSTR1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING RSTR1000,R11                                                     
         ST    R13,RSTRSAVE+4                                                   
         LA    R13,RSTRSAVE                                                     
         LTR   R5,R1               BUILD COMMAND FROM STREAM HERE               
         LTR   R6,R0               MAX THAT CAN FIT IN A COMMAND                
         ST    R5,RSTRCADR         STORE PASSED COMMAND ADDRESS                 
         ST    R6,RSTRCLNG         STORE PASSED COMMAND LENGTH                  
*                                                                               
* * GET A TELNET RECORD FOR THE CALLER                                          
* * RECORD MEANS GET A STREAM AND SCAN UNTIL WE GET A END OF LINE...            
         ICM   R3,15,SESRWADR      DO WE HAVE A STREAM POINTER?                 
         BZ    RSTR1800            BIF NO GET SOME DATA                         
         LA    R1,SESRDATA         START OF STREAM                              
         L     R2,SESRWLNG         LENGTH OF STREAM                             
         LA    R4,0(R2,R1)         END OF STREAM                                
         SLR   R4,R3               CALCULATE LENGTH LEFT                        
         B     RSTR3400            PICK UP HERE...                              
RSTR1800 DS    0H                                                               
         LA    R0,L'SESRDATA       LENGTH OF RECEIVE AREA                       
         ST    R0,TSKFWRK1         STORE IT                                     
*                                                                               
* * BSD-C RECV FUNCTION CALL...                                                 
         LA    R1,TSKSOCKN         @ OF SOCKET NUMBER                           
         ST    R1,TSKPARMS+0       STORE IT                                     
         LA    R1,SESRDATA         @ OF AREA TO RECEIVE THE DATA                
         ST    R1,TSKPARMS+4       STORE IT                                     
         LA    R1,TSKFWRK1         @ OF RECEIVE AREA LENGTH                     
         ST    R1,TSKPARMS+8       STORE IT                                     
         LA    R1,TSKPARMS         @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRRECV)    @ ACCEPT FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE RECEIVE WORK ?                       
         BM    RSTR9000            BIF NO                                       
         LTR   R4,R15              DID WE GET ANY?                              
         BP    RSTR3000            BIF YES                                      
         LA    R15,8               TELL CALLER IT FAILED                        
         B     RSTR9000            RETURN TO CALLER                             
RSTR3000 DS    0H                                                               
         ST    R4,SESRWLNG         STORE THE LENGTH RECEIVED                    
         LA    R3,SESRDATA         START ADDRESS OF DATA RECEIVED               
         ST    R3,SESRWADR         STORE THE NEW POINTER                        
RSTR3400 DS    0H                                                               
         CLI   0(R3),ASCEOL        IS THIS A ASCII END OF LINE ?                
         BE    RSTR5000            BIF YES                                      
         CLI   0(R3),EBCEOL        IS THIS A EBCIDIC END OF LINE ?              
         BE    RSTR6000            BIF YES                                      
         MVC   0(1,R5),0(R3)       MOVE A BYTE INTO BUFFER                      
         LA    R3,1(,R3)           BUMP TO NEXT IN STREAM                       
         LA    R5,1(,R5)           BUMP TO NEXT IN COMMAND                      
         BCT   R4,RSTR4000         IF NOT ZERO GOTO RSTR4000                    
         B     RSTR1800            DO A RECEIVE FOR MORE OF STREAM              
RSTR4000 DS    0H                                                               
         BCT   R6,RSTR3400         DO IT AGAIN                                  
*                                                                               
* * IF WE FALL THRU THE ABOVE BCT THAN WE HAVE SCANNED FOR 80                   
* * BYTES AND HAVE NOT HIT A END OF LINE CHARACTER...                           
         DC    H'0'                SHOULD NEVER OCCUR                           
RSTR5000 DS    0H                                                               
         OI    TSKFLAG1,TSKASCII   TELL CALLER DATA IS ASCII                    
         B     RSTR8000                                                         
RSTR6000 DS    0H                                                               
         NI    TSKFLAG1,X'FF'-TSKASCII DATA IS NOT ASCII                        
         B     RSTR8000                                                         
RSTR8000 DS    0H                                                               
         LA    R3,1(,R3)           BUMP PAST END OF LINE                        
         BCT   R4,RSTR8200                                                      
         SLR   R3,R3               NO MORE DATA IN STREAM                       
RSTR8200 DS    0H                                                               
         ST    R3,SESRWADR         STORE UPDATED POINTER INTO STREAM            
         L     R1,RSTRCADR         R1 = ADDRESS OF THE COMMAND                  
         LR    R0,R5               R0 = RECORD LENGTH                           
         SR    R0,R1               CALCULATE THE RECORD LENGTH                  
         LA    R15,0               RC = GOOD                                    
RSTR9000 DS    0H                                                               
         L     R13,RSTRSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BR    R14                 RETURN TO CALLER                             
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
* * R0 = MESSAGE LENGTH                                                         
* * R1 = MESSAGE TEXT                                                           
         USING TSKWORK,R8          TO USE DURING CARD1000                       
         USING BSDBEGIN,R9                                                      
         DC    CL8'CONO1000'                                                    
CONO1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15             GET A BASE REGISTER                          
         USING CONO1000,R11                                                     
         LR    R4,R0               MESSAGE LENGTH                               
         LR    R5,R1               MESSAGE TEXT                                 
         LOCK  CONOLOCK,FAIL=WAIT  SINGLE THREAD SUBTASKS THRU HERE             
         ST    R13,CONOSAVE+4      STORE CALLERS R13                            
         LA    R13,CONOSAVE        PROVIDE SAVEAREA                             
         XC    CONOUT,CONOUT       CLEAR CONSOLE I/O AREA                       
         LTR   R2,R4               IS THE MESSAGE LENGTH ZERO                   
         BNZ   CONO2000            PUT OUT INVALID MESSAGE MESSAGE              
         LA    R0,L'CONOBAD1                                                    
         LA    R1,CONOBAD1         PUT OUT THIS MESSAGE                         
CONO2000 DS    0H                                                               
         LA    R0,L'CONOUT                                                      
         CLR   R2,R0               IS IT TOO BIG                                
         BL    CONO3000            BIF NO                                       
         LR    R2,R0               USE THE MAX                                  
CONO3000 DS    0H                                                               
         BCTR  R2,0                MINUS 1 FOR THE EXECUTE                      
         EX    R2,CONOMVC                                                       
CONO4000 DS    0H                                                               
         AMODESW SET,AMODE=24                                                   
         PUT   CONSOLE                                                          
         WAIT  CONSOLE                                                          
         AMODESW SET,AMODE=31                                                   
CONO9000 DS    0H                                                               
         LA    R15,0               RETURN CODE                                  
         L     R13,CONOSAVE+4      RESTORE CALLERS R13                          
         UNLOCK CONOLOCK           RELEASE THE LOCK                             
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CONOMVC  MVC   CONOUT+0(0),0(R5)   EXECUTED INSTRUCTION                         
CONOBAD1 DC    C'CONOBAD1'                                                      
CONOSAVE DS    18F                                                              
CONOWRK1 DS    XL16                                                             
CONOLOCK DTL   NAME=SAMSRVLOCKCN,  NAME OF THIS LOCK                   X        
               CONTROL=E,          EXCLUSIVE USE                       X        
               KEEP=NO,            RELEASE AT END OF STEP              X        
               LOCKOPT=1,          NO OTHER TASK ALLOWED               X        
               OWNER=TASK,         UNLOCKS WILL BE DONE BY THIS TASK   X        
               SCOPE=INT           ONLY FOR THIS SYSTEM                         
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'CARD1000'                                                    
CARD1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING CARD1000,R11                                                     
         ST    R13,CARDSAVE+4                                                   
         LA    R13,CARDSAVE                                                     
         AMODESW SET,AMODE=24      SWITCH TO 24 BIT MODE FOR OPEN               
         OPEN  CARDIN                                                           
         OI    COMFLAG1,CARDACTV   FLAG AS CARD ROUTINE IS ACTIVE               
CARD2000 DS    0H                                                               
         GET   CARDIN                                                           
         TM    COMFLAG1,INITERR    ARE WE JUST FLUSHING SYSRDR CARDS?           
         BO    CARD2000            BIF YES                                      
         LA    R0,L'CARDAREA                                                    
         LA    R1,CARDAREA         PASS CARD TO BE A COMMAND                    
         L     R15,@CMNDRTN        CALL THE COMMAND PROCESSOR                   
         BASSM R14,R15                                                          
*                                                                               
* * ALL COMMANDS GIVE A RESPONSE SO LETS DISPLAY IT ON THE CONSOLE              
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     CARD2000            GET NEXT CARD                                
CARD9000 DS    0H                                                               
         CLOSE CARDIN                                                           
         NI    COMFLAG1,X'FF'-CARDACTV SHUT OFF CARD ACTIVE FLAG                
         OI    COMFLAG1,CARDDONE   SET FLAG FOR CARD COMMANDS DONE              
         LA    R15,0               RETURN CODE                                  
         L     R13,CARDSAVE+4                                                   
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CARDSAVE DS    18F                                                              
CARDAREA DS    CL80                                                             
CARDIN   DTFDI IOAREA1=CARDAREA,                                       C        
               DEVADDR=SYSRDR,                                         C        
               RECSIZE=80,                                             C        
               EOFADDR=CARD9000                                                 
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'CMND1000'                                                    
CMND1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING CMND1000,R11                                                     
         ST    R13,CMNDSAVE+4                                                   
         LA    R13,CMNDSAVE                                                     
*                                                                               
* * LETS PARSE IT ASSUMING PARMS SEPARATED BY 1 OR MORE BLANKS                  
         LTR   R2,R1               @ OF PASSED COMMAND LINE                     
         LTR   R3,R0               LENGTH OF COMMAND LINE                       
         XC    TSKPARMS,TSKPARMS   CLEAR THE PARM AREA                          
         LA    R4,TSKPARMS         PARSE IT HERE                                
CMND2000 DS    0H                                                               
         CLI   0(R2),X'40'         IS IT A BLANK?                               
         BE    CMND2400            BIF YES                                      
         ICM   R5,15,0(R4)         DID WE HAVE A START ADDRESS                  
         BNZ   CMND2600            BIF NO                                       
         ST    R2,0(R4)            @ START OF PARM                              
         B     CMND2600            BUMP ALONG                                   
CMND2400 DS    0H                                                               
         ICM   R5,15,0(R4)         DID WE HAVE A START ADDRESS                  
         BZ    CMND2600            BIF NO                                       
         LR    R1,R2                                                            
         SR    R1,R5               CALCULATE LENGTH OF THE PARM                 
         ST    R1,4(R4)            STORE ITS LENGTH                             
         LA    R4,8(,R4)           BUMP TO SET UP FOR NEXT PARM                 
CMND2600 DS    0H                                                               
         LA    R2,1(,R2)           BUMP TO NEXT BYTE                            
         BCT   R3,CMND2000         LOOP THRU WHOLE LINE                         
         ICM   R5,15,0(R4)         DID THIS LAST PARM GO TO THE END             
         BZ    CMND2680            BIF NO                                       
         SR    R2,R5               CALCULATE LENGTH OF LAST PARM                
         ST    R2,4(R4)            STORE ITS LENGTH                             
CMND2680 DS    0H                                                               
*                                                                               
* * FIND THE COMMAND TO PROCESS                                                 
         LA    R2,CMNDTABL         @ OF COMMAND TABLE                           
         LA    R3,CMNDTCNT         NUMBER OF COMMANDS IN THE TABLE              
         L     R4,TSKPARMS+0       @ OF COMMAND VERB                            
         L     R5,TSKPARMS+4       LENGTH OF COMMAND VERB                       
         BCTR  R5,0                MINUS 1 FOR CLC                              
CMND3000 DS    0H                                                               
         EX    R5,CMNDCLC          IS THIS THE DESIRED COMMAND?                 
         BE    CMND4000            BIF YES                                      
         LA    R2,CMNDENTL(,R2)    BUMP TO THE NEXT COMMAND                     
         BCT   R3,CMND3000         TRY AGAIN                                    
         LA    R0,L'BADCMND                                                     
         LA    R1,BADCMND                                                       
         LA    R15,8                                                            
         B     CMND9000            EXIT NOW                                     
BADCMND  DC    CL8'BADCMND'                                                     
CMND4000 DS    0H                                                               
         LA    R1,TSKPARMS         PASS THE PARSED COMMAND PARMS                
         L     R15,8(R2)           GET THE COMMAND PROCESSOR RTN                
         BASSM R14,R15             CALL THE COMMAND PROCESSOR                   
CMND9000 DS    0H                                                               
         L     R13,CMNDSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CMNDCLC  CLC   0(0,R2),0(R4)       IS THIS THE COMMAND?                         
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
* *                                                                             
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'SETPORT'                                                     
SETP1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING SETP1000,R11                                                     
         ST    R13,SETPSAVE+4                                                   
         LA    R13,SETPSAVE                                                     
         LR    R3,R1                                                            
         USING CMDPARMS,R3                                                      
         ICM   R5,15,CMDOP1        @ OF PORT TO BE USED                         
         BNZ   SETP2000                                                         
         LA    R0,L'SETPNOP                                                     
         LA    R1,SETPNOP                                                       
         LA    R15,8                                                            
         B     SETP9000            EXIT NOW                                     
SETPNOP  DC    CL8'SETPNOP'                                                     
SETP2000 DS    0H                                                               
         L     R4,CMDOP1+4         LENGTH OF OPERAND                            
         CL    R4,=F'6'            IS IT LESS THAN 6 DIGITS                     
         BL    SETP3000            BIF YES                                      
         LA    R0,L'SETPBOPL                                                    
         LA    R1,SETPBOPL                                                      
         L     R15,8                                                            
         B     SETP9000            EXIT NOW                                     
SETPBOPL DC    CL8'SETPBOPL'                                                    
SETP3000 DS    0H                                                               
         BCTR  R4,0                MINUS 1 FOR TRT                              
         L     R6,=A(NUMVTAB)      @ OF NUMERIC VALIDATION TRT TABLE            
         EX    R4,SETPTRT          VALIDATE ALL NUMERIC WITH A TRT              
         BZ    SETP4000            NUMBER IS VALID                              
         LA    R0,L'SETPINVN                                                    
         LA    R1,SETPINVN                                                      
         L     R15,8                                                            
         B     SETP9000            EXIT NOW                                     
SETPINVN DC    CL8'SETPINVN'                                                    
SETP4000 DS    0H                                                               
         LA    R2,L'DWORK          8 BYTES                                      
         BCTR  R2,0                MINUS 1                                      
         SLL   R2,4                MOVE IT OVER 4 BITS                          
         OR    R2,R4               OR IN THE LOW-ORDER 4 BIT LENGTH             
         EX    R2,SETPPACK         EXECUTE THE PACK INSTRUCTION                 
         CVB   R2,DWORK            CONVERT PACKED TO BINARY                     
         CL    R2,=F'65536'        IS IT LESS THAN THIS                         
         BL    SETP5000            BIF YES                                      
         LA    R0,L'SETPTOOB                                                    
         LA    R1,SETPTOOB                                                      
         L     R15,8                                                            
         B     SETP9000            EXIT NOW                                     
SETPTOOB DC    CL8'SETPTOOB'                                                    
SETP5000 DS    0H                                                               
         TM    COMFLAG1,CARDACTV   WAS COMMAND FROM THE CARD READER             
         BO    SETP5200            BIF YES                                      
         LA    R0,L'SETPCARD                                                    
         LA    R1,SETPCARD                                                      
         L     R15,8                                                            
         B     SETP9000            EXIT NOW                                     
SETPCARD DC    CL8'SETPCARD'                                                    
SETP5200 DS    0H                                                               
         STH   R2,SOCKPORT         STORE IT                                     
         LA    R0,20                                                            
         L     R1,CMDVERB                                                       
         LA    R15,0               RETURN CODE                                  
SETP9000 DS    0H                                                               
         L     R13,SETPSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
SETPSAVE DS    18F                                                              
SETPPACK PACK  DWORK(0),0(0,R5)    CONVERT ZONED DECIMAL TO PACKED              
SETPTRT  TRT   0(0,R5),0(R6)       EXECUTED INSTRUCION                          
NUMVTAB  DS    0D                                                               
         DC    240X'FF'                                                         
         DC    10X'00'             X'F0' - X'F9' ARE VALID                      
         DC    6X'FF'                                                           
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'SHUT1000'                                                    
SHUT1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING SHUT1000,R11                                                     
         ST    R13,SHUTSAVE+4                                                   
         LA    R13,SHUTSAVE                                                     
*                                                                               
* * FIRST LETS CLOSE THE CURRENTLY OPEN PASSIVE TCP SOCKET...                   
*                                                                               
* * BSD-C CLOSE FUNCTION CALL...                                                
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,TSKPARMS+0       STORE IT                                     
         LA    R1,TSKPARMS         @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRCLOS)    @ CLOSE FUNCTION ROUTINE                     
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE SOCKET GET CLOSED ?                  
         BZ    SHUT6000            BIF YES                                      
         DC    H'0'                NEVER SHOULD OCCURR...                       
         LA    R0,L'SHUTWFAL                                                    
         LA    R1,SHUTWFAL                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     SHUT6000            POST THE SHUTDOWN ECB ANYWAY                 
SHUTWFAL DC    C'SHUTWFAL'                                                      
SHUT6000 DS    0H                                                               
         OI    COMFLAG1,MAINSHUT   FLAG MAIN IS SHUTTING DOWN                   
         LA    R1,SHUTECB          POST THIS ECB                                
         POST  (1)                 MAKE ALL TASKS READY TO RUN                  
         LA    R0,L'SHUTDOWN                                                    
         LA    R1,SHUTDOWN                                                      
         LA    R15,0               RETURN CODE                                  
SHUT9000 DS    0H                                                               
         L     R13,SHUTSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
SHUTSAVE DS    18F                                                              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'CALP1000'                                                    
CALP1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING CALP1000,R11                                                     
         ST    R13,CALPSAVE+4                                                   
         LA    R13,CALPSAVE                                                     
         LR    R3,R1                                                            
         USING CMDPARMS,R3                                                      
         ICM   R4,15,CMDOP1        @ OF PHASE NAME TO BE CALLED                 
         BNZ   CALP2000                                                         
         LA    R0,L'CALPNPHS                                                    
         LA    R1,CALPNPHS                                                      
         LA    R15,8                                                            
         B     CALP9000            EXIT NOW                                     
CALPNPHS DC    CL8'CALPNPHS'                                                    
CALP2000 DS    0H                                                               
         MVC   CALPPHAS,BLNKLINE   INIT PHASE NAME TO BLANKS                    
         L     R2,CMDOP1+4         LENGTH OF PHASE NAME                         
         BCTR  R2,0                MINUS 1                                      
         EX    R2,CALPMVC1         MOVE THE DESIRED PHASE NAME                  
         LA    R1,CALPPHAS         CDLOAD THIS PHASE                            
         CDLOAD (1),RETPNF=YES                                                  
         LTR   R15,R15             DID IT WORK                                  
         BZ    CALP3000            BIF YES                                      
         LA    R0,L'CALPCDLF                                                    
         LA    R1,CALPCDLF                                                      
         LA    R15,8                                                            
         B     CALP9000            EXIT                                         
CALPCDLF DC    C'CALPCDLF'                                                      
CALP3000 DS    0H                                                               
         ST    R0,CALP@LOD         STORE THE PHASE LOAD POINT                   
         ST    R1,CALP@ENT         STORE THE PHASE ENTRY POINT                  
         ST    R14,CALPLPHS        STORE THE LENGTH OF THE PHASE                
         LA    R0,CALPMSGL                                                      
         LA    R1,CALPMSG1                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         L     R0,CMDOP2+4         LENGTH OF OPERAND 2                          
         L     R1,CMDOP2+0         @ OF OPERAND 2                               
         L     R15,CALP@ENT        PHASE TO BE CALLED                           
         BASSM R14,R15             GO FOR IT                                    
         LA    R0,L'CALPDONE                                                    
         LA    R1,CALPDONE                                                      
         LA    R15,0                                                            
CALP9000 DS    0H                                                               
         L     R13,CALPSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CALPDONE DC    C'CALLED PROGRAM DONE'                                           
CALP@LOD DS    F                   PHASE LOAD POINT                             
CALP@ENT DS    F                   PHASE ENTRY POINT                            
CALPLPHS DS    F                   LENGTH OF THE PHASE                          
CALPMSG1 DS    0H                                                               
         DC    C'CALLING PHASE '                                                
CALPPHAS DC    CL8'X'                                                           
CALPMSGL EQU   *-CALPMSG1                                                       
CALPMVC1 MVC   CALPPHAS(0),0(R4)   EXECUTED INSTRUCTION                         
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'CDLD1000'                                                    
CDLD1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING CDLD1000,R11                                                     
         ST    R13,CDLDSAVE+4                                                   
         LA    R13,CDLDSAVE                                                     
         LR    R3,R1                                                            
         USING CMDPARMS,R3                                                      
         ICM   R4,15,CMDOP1        @ OF PHASE NAME TO BE CALLED                 
         BNZ   CDLD2000                                                         
         LA    R0,L'CDLDNPHS                                                    
         LA    R1,CDLDNPHS                                                      
         LA    R15,8                                                            
         B     CDLD9000            EXIT NOW                                     
CDLDNPHS DC    CL8'CDLDNPHS'                                                    
CDLD2000 DS    0H                                                               
         MVC   CDLDPHAS,BLNKLINE   INIT PHASE NAME TO BLANKS                    
         L     R2,CMDOP1+4         LENGTH OF PHASE NAME                         
         BCTR  R2,0                MINUS 1                                      
         EX    R2,CDLDMVC1         MOVE THE DESIRED PHASE NAME                  
         LA    R1,CDLDPHAS         CDLOAD THIS PHASE                            
         CDLOAD (1),RETPNF=YES                                                  
         LTR   R15,R15             DID IT WORK                                  
         BZ    CDLD3000            BIF YES                                      
         LA    R0,L'CDLDFAIL                                                    
         LA    R1,CDLDFAIL                                                      
         LA    R15,8                                                            
         B     CDLD9000            EXIT                                         
CDLDFAIL DC    C'CDLDFAIL'                                                      
CDLD3000 DS    0H                                                               
         ST    R0,CDLD@LOD         STORE THE PHASE LOAD POINT                   
         ST    R1,CDLD@ENT         STORE THE PHASE ENTRY POINT                  
         ST    R14,CDLDLPHS        STORE THE LENGTH OF THE PHASE                
         UNPK  CDLDWRK1(9),CDLD@LOD(5) UNPACK                                   
         TR    CDLDWRK1(8),TRTAB    TRANSLATE TO HEX                            
         MVC   CDLDMLOD,CDLDWRK1   MOVE INTO THE MESSAGE                        
         UNPK  CDLDWRK1(9),CDLDLPHS(5) UNPACK                                   
         TR    CDLDWRK1(8),TRTAB    TRANSLATE TO HEX                            
         MVC   CDLDMLNG,CDLDWRK1   MOVE INTO THE MESSAGE                        
         LA    R0,CDLDMSGL                                                      
         LA    R1,CDLDMSG1                                                      
         LA    R15,0               RC = GOOD                                    
CDLD9000 DS    0H                                                               
         L     R13,CDLDSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CDLD@LOD DS    F                   PHASE LOAD POINT                             
CDLD@ENT DS    F                   PHASE ENTRY POINT                            
CDLDLPHS DS    F                   LENGTH OF THE PHASE                          
CDLDMSG1 DS    0H                                                               
         DC    C'PHASE '                                                        
CDLDPHAS DC    CL8'X'                                                           
         DC    C' CDLOADED AT '                                                 
CDLDMLOD DC    CL8'X'                                                           
         DC    C' LENGTH='                                                      
CDLDMLNG DC    CL8'X'                                                           
CDLDMSGL EQU   *-CDLDMSG1                                                       
CDLDMVC1 MVC   CDLDPHAS(0),0(R4)   EXECUTED INSTRUCTION                         
CDLDWRK1 DS    XL80                                                             
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'HART1000'                                                    
*                                                                               
* * SIMPLE ECHO REPLY TO CALLER...                                              
HART1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING HART1000,R11                                                     
         ST    R13,HARTSAVE+4                                                   
         LA    R13,HARTSAVE                                                     
         LA    R0,8                LENGTH OF REPLY                              
         LA    R1,HARTBEAT         @ OF REPLY                                   
         LA    R15,0               RC=GOOD                                      
HART9000 DS    0H                                                               
         L     R13,HARTSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'CONT1000'                                                    
CONT1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING CONT1000,R11                                                     
         ST    R13,CONTSAVE+4                                                   
         LA    R13,CONTSAVE                                                     
         LR    R3,R1                                                            
         USING CMDPARMS,R3                                                      
         SOCKET   OPEN,CONTROL,    OPEN THE CONTROL CONNECTION         *        
               DESC=TSKCDESC,      DESCRIPTOR                          *        
               MFG=TSKCMFG,        WORK AREA                           *        
               ECB=TSKCECB         ECB ADDRESS                                  
         LTR   R15,R15             DID IT OPEN                                  
         BZ    CONT2200            BIF YES                                      
         LA    R0,L'CONTOPNF                                                    
         LA    R1,CONTOPNF                                                      
         LA    R15,8                                                            
         B     CONT9000            EXIT NOW                                     
CONTOPNF DC    CL8'CONTOPNF'                                                    
CONT2200 DS    0H                                                               
         LA    R1,TSKCECB          @ OF ECB TO WAIT ON                          
         WAIT  (1)                 VSE WAIT                                     
         USING SRBLOK,R1                                                        
         CLI   SRCODE,SROPGOOD     WAS THE OPEN CLEAN?                          
         BE    CONT2400            BIF YES                                      
         DROP  R1                                                               
         LA    R0,L'CONTOPNB                                                    
         LA    R1,CONTOPNB                                                      
         LA    R15,8                                                            
         B     CONT9000            EXIT NOW                                     
CONTOPNB DC    CL8'CONTOPNB'                                                    
CONT2400 DS    0H                                                               
         ICM   R4,15,CMDOP1        @ OF CONTROL COMMAND                         
         BNZ   CONT2600                                                         
         LA    R0,L'CONTNCMD                                                    
         LA    R1,CONTNCMD                                                      
         LA    R15,8                                                            
         B     CONT9000            EXIT NOW                                     
CONTNCMD DC    CL8'CONTNCMD'                                                    
CONT2600 DS    0H                                                               
*                                                                               
* * FIND THE REQUESTED CONTROL COMMAND                                          
         LA    R2,CONTTABL         @ OF COMMAND TABLE                           
         LA    R0,CONTTCNT         NUMBER OF COMMANDS IN THE TABLE              
         L     R5,CMDOP1+4         LENGTH OF CONTROL COMMAND                    
         BCTR  R5,0                MINUS 1 FOR CLC                              
CONT3000 DS    0H                                                               
         EX    R5,CONTCLC          IS THIS THE DESIRED COMMAND?                 
         BE    CONT4000            BIF YES                                      
         LA    R2,CONTENTL(,R2)    BUMP TO THE NEXT COMMAND                     
         BCT   R0,CONT3000         TRY AGAIN                                    
         LA    R0,L'CONTBCMD                                                    
         LA    R1,CONTBCMD                                                      
         LA    R15,8                                                            
         B     CONT9000            EXIT NOW                                     
CONTBCMD DC    CL8'CONTBCMD'                                                    
CONTCLC  CLC   0(0,R2),0(R4)       IS THIS THE COMMAND?                         
CONTMVC1 MVC   0(0,R1),0(R4)       EXECUTED INSTRUCTION                         
CONT4000 DS    0H                                                               
         MVC   TSKCBUFF,BLNKLINE   INIT IT TO BLANKS                            
         LA    R1,TSKCBUFF         MOVE STUFF TO STARTING HERE                  
         EX    R5,CONTMVC1         MOVE THE COMMAND                             
         LA    R1,2(R5,R1)         BUMP TO NEXT SPOT                            
         L     R15,16(R2)          @ OF ROUTINE TO HANDLE IT                    
         BALR  R14,R15             HANDLE IT                                    
         STM   R15,R1,TSKCR3F      STORE RETURN CODE AND MSG POINTER            
         SOCKET   CLOSE,CONTROL,   CLOSE THE CONTROL SESSION           *        
               DESC=TSKCDESC,      DESCRIPTIOR                         *        
               MFG=TSKCMFG,        WORK AREA                           *        
               ECB=TSKCECB         ECB ADDRESS                                  
         LTR   R15,R15             DID IT WORK ?                                
         BZ    CONT5200            BIF YES                                      
         LA    R0,L'CONTCLSF                                                    
         LA    R1,CONTCLSF                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     CONT8000                                                         
CONTCLSF DC    CL8'CONTCLSF'                                                    
CONT5200 DS    0H                                                               
         LA    R1,TSKCECB          @ OF ECB TO WAIT ON                          
         WAIT  (1)                                                              
CONT8000 DS    0H                                                               
         LM    R15,R1,TSKCR3F      RESTORE RETURN CODE AND MSG POINTER          
CONT9000 DS    0H                                                               
         L     R13,CONTSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CONTTABL DS    0F                                                               
         DC    CL16'GETHOSTBYNAME   ',A(GETH1000)                               
CONTENTL EQU   20                  LENGTH OF A SINGLE TABLE ENTRY               
CONTTCNT EQU   (*-CONTTABL)/CONTENTL NUMBER OF TABLE ITEMS                      
CONTGOOD DC    CL8'CONTGOOD'                                                    
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING CMDPARMS,R3                                                      
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'GETH1000'                                                    
GETH1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING GETH1000,R11                                                     
         ST    R13,GETHSAVE+4                                                   
         LA    R13,GETHSAVE                                                     
         ICM   R4,15,CMDOP2        @ OF HOST NAME                               
         BNZ   GETH2000                                                         
         LA    R0,L'GETHNHST                                                    
         LA    R1,GETHNHST                                                      
         LA    R15,8                                                            
         B     GETH9000            EXIT NOW                                     
GETHNHST DC    CL8'GETHNHST'                                                    
GETH2000 DS    0H                                                               
         ICM   R2,15,CMDOP2+4      LENGTH OF HOST NAME                          
         BCTR  R2,0                MINUS 1 FOR MVC                              
         EX    R2,GETHMVC                                                       
         LA    R1,2(R2,R1)         BUMP                                         
         MVI   0(R1),EBCEOL        INSERT THE END OF COMMAND                    
         LA    R1,1(,R1)           BUMP                                         
         L     R15,=A(SNDR1000)                                                 
         BALR  R14,R15             ISSUE SEND/RECEIVE                           
         LTR   R15,R15             DID IT WORK                                  
         BNZ   GETH9000            BIF NO                                       
*                                                                               
*        COPY THE DATA FROM THE BUFFER                                          
         MVC   GETHIPAD,TSKCBUFF   COPY THE BINARY IP ADDRESS                   
         MVC   GETHICHR,TSKCBUFF+4 COPY THE CHARACTER IP ADDRESS                
         LA    R1,TSKCBUFF+4       DATA TO BE DISPLAYED                         
         LA    R0,15               LENGTH OF DATA TO BE DISPLAYED               
         LA    R15,0               RETURN CODE                                  
GETH9000 DS    0H                                                               
         L     R13,GETHSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
GETHMVC  MVC   0(0,R1),0(R4)       MOVE HOST NAME                               
GETHIPAD DS    XL4                                                              
GETHICHR DS    CL15                                                             
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         USING TSKWORK,R8                                                       
         USING BSDBEGIN,R9                                                      
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         DC    CL8'SNDR1000'                                                    
SNDR1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING SNDR1000,R11                                                     
         ST    R13,SNDRSAVE+4                                                   
         LA    R13,SNDRSAVE                                                     
         LR    R3,R1               END OF DATA BUFFER                           
         LA    R0,TSKCBUFF         START OF BUFFER                              
         SR    R3,R0               CALCULATE LENGTH OF BUFFER TO SEND           
         ST    R3,TSKCLEN          LENGTH OF BUFFER TO SEND                     
         LA    R4,TSKCBUFF         @ OF BUFFER TO BE SENT                       
         ST    R4,TSKCADDR         STORE IT                                     
         SOCKET   SEND,CONTROL,            SEND CONTROL COMMAND        *        
               DATA=(TSKCADDR,TSKCLEN),    DATA TO BE SENT             *        
               DESC=TSKCDESC,              DESCRIPTOR                  *        
               MFG=TSKCMFG,                WORK AREA                   *        
               ECB=TSKCECB                 ECB ADDRESS                          
         LTR   R15,R15             DID IT WORK                                  
         BZ    SNDR2000            BIF YES                                      
         LA    R0,L'SNDRSNDF                                                    
         LA    R1,SNDRSNDF                                                      
         LA    R15,8                                                            
         B     SNDR9000            EXIT NOW                                     
SNDRSNDF DC    CL8'SNDRSNDF'                                                    
SNDR2000 DS    0H                                                               
         LA    R1,TSKCECB          @ OF THE ECB TO WAIT ON                      
         WAIT  (1)                                                              
         USING SRBLOK,R1                                                        
         CLI   SRCODE,SROPGOOD     WAS IT GOOD                                  
         BE    SNDR3000            BIF YES                                      
         LA    R0,L'SNDRSSRC                                                    
         LA    R1,SNDRSSRC                                                      
         LA    R15,8                                                            
         B     SNDR9000            EXIT NOW                                     
SNDRSSRC DC    CL8'SNDRSSRC'                                                    
         DROP  R1                                                               
SNDR3000 DS    0H                                                               
*                                                                               
*        LET'S GET THE RESPONSE                                                 
         MVC      TSKCLEN(4),=F'80' SET THE RECEIVE LENGTH                      
         LA       R4,TSKCBUFF              ADDRESS THE BUFFER                   
         ST       R4,TSKCADDR              SAVE THE ADDRESS                     
         SOCKET   RECEIVE,CONTROL,         RECEIVE THE RESPONSE        *        
               DATA=(TSKCADDR,TSKCLEN),    INDENTIFY THE DATA          *        
               DESC=TSKCDESC,              DESCRIPTOR                  *        
               MFG=TSKCMFG,                WORK AREA                   *        
               ECB=TSKCECB                 ECB ADDRESS                          
         LTR   R15,R15             DID IT WORK                                  
         BZ    SNDR4000            BIF YES                                      
         LA    R0,L'SNDRRECF                                                    
         LA    R1,SNDRRECF                                                      
         LA    R15,8                                                            
         B     SNDR9000            EXIT NOW                                     
SNDRRECF DC    CL8'SNDRRECF'                                                    
SNDR4000 DS    0H                                                               
         LA    R1,TSKCECB          @ OF ECB                                     
         WAIT  (1)                                                              
         USING SRBLOK,R1                                                        
         CLI   SRCODE,SROPGOOD     WAS THE OPEN GOOD?                           
         BE    SNDR4200            BIF YES                                      
         LA    R0,L'SNDRRECB                                                    
         LA    R1,SNDRRECB                                                      
         LA    R15,8                                                            
         B     SNDR9000            EXIT NOW                                     
SNDRRECB DC    CL8'SNDRRECB'                                                    
SNDR4200 DS    0H                                                               
         SLR   R0,R0               CLEAR REG                                    
         ICM   R0,B'0011',SRCOUNT  NUMBER OF BYTES RECEIVED                     
         DROP  R1                                                               
         LA    R15,0               GOOD NEW RETURN CODE                         
SNDR9000 DS    0H                                                               
         L     R13,SNDRSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
*                                                                               
         DC    CL8'OCEX1000'                                                    
OCEX1000 DS    0H                                                               
         LR    R11,R15                                                          
         USING OCEX1000,R11                                                     
         L     R12,=A(BSDSERVR)    MAIN CSECT                                   
         USING BSDSERVR,R12                                                     
         L     R9,=A(BSDBEGIN)     @ OF MAINTASK COMMON AREA                    
         USING BSDBEGIN,R9                                                      
         LR    R4,R1               @ OF PASSED MAPSAVAR                         
         USING SVUARA,R4                                                        
         LA    R13,OCEXSAV2                                                     
         MVC   OCEXCMND,BLNKLINE   CLEAR THE COMMAND LINE                       
         CLI   SVUMGADR,X'00'      WAS DATA= PASSED?                            
         BE    OCEX2000            BIF NO                                       
         MVC   OCEXCMND,SVUMGADR   GET THE DATA=                                
         OC    OCEXCMND,BLNKLINE   TRANSLATE TO UPPER CASE                      
         B     OCEX4000            ALL SET                                      
OCEX2000 DS    0H                                                               
         MVC   OCEXCMND(8),DOAREADC TELL MAIN TO READ FROM CONSOLE              
OCEX4000 DS    0H                                                               
         LA    R1,CMNDECB          POST THIS ECB                                
         POST  (1)                 MAKE MAINTASK READY TO RUN                   
OCEX9000 DS    0H                                                               
         EXIT  OC                  RETURN TO MAIN TASK                          
OCEXSAV1 DS    XL256               STXIT OC EXIT SAVE AREA                      
OCEXSAV2 DS    18F                                                              
DOAREADC DC    C'DOAREADC'                                                      
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
         DC    CL8'MNAB1000'                                                    
MNAB1000 DS    0H                                                               
         LR    R11,R15                                                          
         USING MNAB1000,R11                                                     
         ST    R0,MNABR0           STORE THE VSE ABEND CODE                     
         L     R12,=A(BSDSERVR)    MAIN CSECT                                   
         LA    R6,2048(,R12)       SET 2ND BASE REG                             
         LA    R6,2048(,R6)        "                                            
         USING BSDSERVR,R12        ESTABLISH NEW BASE REGISTER                  
         L     R9,=A(BSDBEGIN)     @ OF MAINTASK COMMON AREA                    
         USING BSDBEGIN,R9                                                      
         LR    R4,R1               @ OF PASSED MAPSAVAR                         
         USING SVUARA,R4                                                        
         LA    R13,MNABSAV2                                                     
         UNPK  MNABWRK1(9),MNABR0(5) UNPACK                                     
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   MNABCODE,MNABWRK1+6 MOVE INTO THE MESSAGE                        
         UNPK  MNABWRK1(9),SVUAPSW(5) UNPACK                                    
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   MNABPSW1,MNABWRK1   MOVE INTO THE MESSAGE                        
         UNPK  MNABWRK1(9),SVUAPSW+4(5) UNPACK                                  
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   MNABPSW2,MNABWRK1   MOVE INTO THE MESSAGE                        
         UNPK  MNABWRK1(9),SVUPSW(5) UNPACK                                     
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   MNABPINF,MNABWRK1+4 MOVE INTO THE MESSAGE                        
         LA    R0,MNABM1L                                                       
         LA    R1,MNABMSG1                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         LA    R5,4                FIRST DO R0 - R3                             
         LA    R8,SVUR00           START HERE                                   
         MVC   MNABREGS+0(7),=C'R0-R3  '                                        
         LA    R7,MNABREGS+8       BUILD OUTPUT HERE                            
MNAB3000 DS    0H                                                               
         UNPK  MNABWRK1(9),0(5,R8) UNPACK                                       
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   0(8,R7),MNABWRK1    MOVE INTO THE MESSAGE                        
         LA    R8,4(,R8)           BUMP TO NEXT REG                             
         LA    R7,9(,R7)           BUMP                                         
         BCT   R5,MNAB3000                                                      
         LA    R0,MNABRL                                                        
         LA    R1,MNABREGS                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         LA    R5,4                NOW DO R4 - R7                               
         MVC   MNABREGS+0(7),=C'R4-R7  '                                        
         LA    R7,MNABREGS+8       BUILD OUTPUT HERE                            
MNAB3100 DS    0H                                                               
         UNPK  MNABWRK1(9),0(5,R8) UNPACK                                       
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   0(8,R7),MNABWRK1    MOVE INTO THE MESSAGE                        
         LA    R8,4(,R8)           BUMP TO NEXT REG                             
         LA    R7,9(,R7)           BUMP                                         
         BCT   R5,MNAB3100                                                      
         LA    R0,MNABRL                                                        
         LA    R1,MNABREGS                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         LA    R5,4                NOW DO R8 - R11                              
         MVC   MNABREGS+0(7),=C'R8-R11 '                                        
         LA    R7,MNABREGS+8       BUILD OUTPUT HERE                            
MNAB3200 DS    0H                                                               
         UNPK  MNABWRK1(9),0(5,R8) UNPACK                                       
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   0(8,R7),MNABWRK1    MOVE INTO THE MESSAGE                        
         LA    R8,4(,R8)           BUMP TO NEXT REG                             
         LA    R7,9(,R7)           BUMP                                         
         BCT   R5,MNAB3200                                                      
         LA    R0,MNABRL                                                        
         LA    R1,MNABREGS                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         LA    R5,4                NOW DO R12 - R15                             
         MVC   MNABREGS+0(7),=C'R12-R15'                                        
         LA    R7,MNABREGS+8       BUILD OUTPUT HERE                            
MNAB3300 DS    0H                                                               
         UNPK  MNABWRK1(9),0(5,R8) UNPACK                                       
         TR    MNABWRK1(8),TRTAB   TRANSLATE TO HEX                             
         MVC   0(8,R7),MNABWRK1    MOVE INTO THE MESSAGE                        
         LA    R8,4(,R8)           BUMP TO NEXT REG                             
         LA    R7,9(,R7)           BUMP                                         
         BCT   R5,MNAB3300                                                      
         LA    R0,MNABRL                                                        
         LA    R1,MNABREGS                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
*                                                                               
         LA    R5,MNABDLST         @ OF ADDRESSES TO BE DUMPED                  
         ST    R9,0(R5)            DUMP THE TASK SAVE AREA                      
         LA    R1,256(,R9)                                                      
         AL    R1,=F'32000'        PLUS THIS MUCH                               
         ST    R1,4(R5)                                                         
         LA    R5,8(,R5)           BUMP TO NEXT                                 
         L     R1,@SAMSRV          @ OF CODE                                    
         ST    R1,0(R5)            STORE IT                                     
         LA    R1,4095(,R1)                                                     
         ST    R1,4(R5)                                                         
         OI    4(R5),X'80'         FLAG IT AS THE LAST IN THE LIST              
         SDUMPX HDR='BSDSERVR MAINTASK ABEND',LIST=MNABDLST                     
*                                                                               
         L     R8,@TSKWORK         @ OF MAIN TASK WORK AREA                     
         USING TSKWORK,R8                                                       
MNAB4000 DS    0H                                                               
*                                                                               
         EXIT  AB                                                               
         L     R15,MNABR0          GET THE VSE ABEND CODE                       
         ST    R15,RETCODE         STORE IT                                     
         L     R15,MNABRETN        @ OF RETURN ADDRESS                          
         LM    R0,R14,MNABRRGS     RETURN WITH THESE REGS                       
         BR    R15                 RETURN TO HERE...                            
MNABR0   DS    F                                                                
*                                                                               
MNABSAV1 DS    XL256               STXIT AB EXIT SAVE AREA                      
MNABSAV2 DS    18F                                                              
MNABWRK1 DS    XL32                                                             
MNABDLST DS    32F                 UP TO 16 AREAS                               
MNABMSG1 DS    0H                                                               
         DC    C'BSDSERVR ABEND PSW='                                           
MNABPSW1 DC    CL8'X'                                                           
         DC    CL1' '                                                           
MNABPSW2 DC    CL8'X'                                                           
         DC    C' CANCEL CODE='                                                 
MNABCODE DC    CL2'A'                                                           
         DC    C' INT='                                                         
MNABPINF DC    CL4' '                                                           
MNABM1L  EQU   *-MNABMSG1                                                       
MNABREGS DC    CL60' '                                                          
MNABRL   EQU   *-MNABREGS                                                       
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
* * EQUATES...                                                                  
EBCEOL   EQU   X'15'               EBCIDIC END OF LINE INDICATOR                
ASCEOL   EQU   X'0A'               ASCII   END OF LINE INDICATOR                
*                                                                               
* * REGISTER EQUATES                                                            
R0       EQU      0                                                             
R1       EQU      1                                                             
R2       EQU      2                                                             
R3       EQU      3                                                             
R4       EQU      4                                                             
R5       EQU      5                                                             
R6       EQU      6                                                             
R7       EQU      7                                                             
R8       EQU      8                                                             
R9       EQU      9                                                             
R10      EQU      10                                                            
R11      EQU      11                                                            
R12      EQU      12                                                            
R13      EQU      13                                                            
R14      EQU      14                                                            
R15      EQU      15                                                            
*                                                                               
CMDPARMS DSECT                                                                  
CMDVERB  DS    2F                                                               
CMDOP1   DS    2F                                                               
CMDOP2   DS    2F                                                               
CMDOP3   DS    2F                                                               
CMDOP4   DS    2F                                                               
CMDOP5   DS    2F                                                               
CMDOP6   DS    2F                                                               
CMDOP7   DS    2F                                                               
CMDOP8   DS    2F                                                               
*                                                                               
TSKWORK  DSECT                                                                  
TSKFLAG1 DS    XL1                 FLAG 1                                       
TSKATTCH EQU   X'80'               TASK IS ATTACHED                             
TSKINUSE EQU   X'40'               TASK IS IN USE                               
TSKABEND EQU   X'20'               TASK ABENDED                                 
TSKASCII EQU   X'10'               TASK COMMAND IS IN ASCII                     
TSKCONNX EQU   X'08'               TASK IS CONNECTED                            
         DS    XL1                 UNUSED                                       
TSKTID   DS    H                   VSE TASK ID                                  
TSKSAVAR DS    XL120               VSE TASK SAVE AREA                           
TSKSOCKN DS    F                   SOCKET NUMBER                                
TSKRSLT  DS    14F                                                              
TSKTECB  DS    F                   TASK TERMINATION ECB                         
TSKIPADR DS    F                                                                
TSKSAV01 DS    18F                 SAVE AREA FOR CALLING                        
TSKECB1  DS    F                                                                
TSKWAITM DS    0F                  WAITM ECB LIST                               
@TSKECB1 DS    F                                                                
@TSKECB2 DS    F                                                                
@TSKECB3 DS    F                                                                
*                                                                               
IBUFFER  DS    0D                                                               
IFAMILY  DS    H                                                                
IPORT    DS    H                                                                
IIPADDR  DS    F                                                                
ICLEAR   DS    CL8                                                              
IBUFFERL EQU   *-IBUFFER                                                        
*                                                                               
TSKFWRK1 DS    D                                                                
TSKFWRK2 DS    F                                                                
TSKSENDL DS    F                                                                
TSK@SEND DS    F                   @ OF SEND BUFFER                             
TSKCMNDL DS    F                   ACTUAL LENGTH OF TASK COMMAND                
TSKCMND  DS    CL80                TASK COMMAND LINE                            
         DS    0D                                                               
TSKPARMS DS    XL256               ENOUGH FOR 32 PARMS                          
TSKCMFG  DS    (SOPLEN)X                                                        
TSKCDESC DS    F                                                                
TSKCECB  DS    14F                                                              
TSKCBUFF DS    CL80                                                             
TSKCADDR DS    F                                                                
TSKCLEN  DS    F                                                                
TSKCR3F  DS    3F                                                               
CMNDSAVE DS    18F                                                              
CALPSAVE DS    18F                                                              
CDLDSAVE DS    18F                                                              
HARTSAVE DS    18F                                                              
CONTSAVE DS    18F                                                              
GETHSAVE DS    18F                                                              
SNDRSAVE DS    18F                                                              
RSTRSAVE DS    18F                                                              
SESRWLNG DS    F                                                                
SESRWADR DS    F                                                                
RSTRCLNG DS    F                                                                
RSTRCADR DS    F                                                                
SESRDATL DS    F                                                                
SESRDATA DS    XL256                                                            
         DS    XL(4096-(*-TSKWORK))                                             
TSKL     EQU   *-TSKWORK           LENGTH                                       
*                                                                               
COMREG   MAPCOMR  EQU=YES                                                       
         MAPSAVAR ,                                                             
SYSCOM   SYSCOM   ,                                                             
         END   BSDSERVR                                                         
/*                                                                              
*                                                                               
* * EXECUTING LINK EDIT TO CREATE BSDSERVR PHASE...                             
// EXEC LNKEDT,SIZE=512K                                                        
/*                                                                              
*                                                                               
* * EXECUTING SAMPLE BSD SERVER...                                              
// LIBDEF PHASE,SEARCH=DRSLIB.TEST                                              
// EXEC BSDSERVR,SIZE=BSDSERVR  TRACE                                           
/*                                                                              
/&                                                                              
* $$ EOJ                                                                        
