* $$ JOB JNM=BSDCLINT,CLASS=A,DISP=D                                            
* $$ LST CLASS=F,DEST=(,AFTPTODS)                                               
// JOB BSDCLINT                                                                 
// OPTION CATAL                                                                 
// LIBDEF *,SEARCH=(DRSLIB.TEST,PRD1.MACLIB),TEMP                               
// LIBDEF *,CATALOG=DRSLIB.TEST                                                 
*                                                                               
* * EXECUTING ASSEMBLY OF SAMPLE BSD CLIENT CODE...                             
// EXEC ASMA90,SIZE=ASMA90,PARM='SZ(MAX-200K,ABOVE)'                            
         PUNCH '  PHASE BSDCLINT,*'                                             
BSDCLINT CSECT                                                                  
BSDCLINT RMODE 24                                                               
BSDCLINT AMODE 31                                                               
         USING BSDCLINT,R15        ESTABLISH TEMPORARY ADDRESSABILITY           
         B     MAIN1000            LETS GET TO WORK                             
*                                                                               
* * THIS IS A SAMPLE TCP CLIENT APPLICATION THAT USES                           
* * THE BSD-C INTERFACE. IT WILL:                                               
* * OPEN A CONNECTION TO THE SAMPLE BSD SERVER APPLICATION                      
* * READ COMMANDS FROM THE VSE CARD READER                                      
* * DISPLAY THE COMMAND ONTO SYSLOG AND SYSLST                                  
* * SEND THE COMMAND TO THE SERVER APPLICATION                                  
* * ISSUE A RECEIVE AND WAIT FOR A REPLY FROM THE SERVER                        
* * DISPLAY THE REPLY ONTO SYSLOG AND SYSLST                                    
* * AFTER ALL CARDS HAVE BEEN READ IT WILL                                      
* * CLOSE THE CONNECTION AND TERMINATE                                          
*                                                                               
MAINNAME DC    CL8'BSDCLINT'                                                    
COMVERS  DC    CL8'01.05.00'       VERSION AND RELEASE                          
COMADATE DC    CL8'&SYSDATC'       ASSEMBLED DATE                               
COMATIME DC    CL8'&SYSTIME'       ASSEMBLED TIME                               
         ENTRY IPERRNO                                                          
IPERRNO  DS    F                                                                
         ENTRY IPRETCD                                                          
IPRETCD  DS    F                                                                
*                                                                               
PARMS    DS    0D                                                               
PARM1    DS    F                                                                
PARM2    DS    F                                                                
PARM3    DS    F                                                                
PARM4    DS    F                                                                
PARM5    DS    F                                                                
*                                                                               
* * BSD-C PASSED PARAMETER VALUES                                               
BASESOCK DS    F                   SOCKET NUMBER                                
DOMAIN   DC    F'2'                SOCKET.H AF_INET                             
TYPE     DC    F'1'                SOCKET.H SOCK_STREAM                         
PROTOCOL DC    F'2'                SOCKET.H IPPROTO_TCP                         
*                                                                               
SOCKADDR DS    0F                  SOCKET.H struct sockaddr_in                  
         DC    H'2'                SOCKET.H AF_INET                             
SOCKPORT DC    H'6045'             PORT ADDRESS OF SERVER                       
SOCKIPAD DC    AL1(12),AL1(182),AL1(34),AL1(5) IP ADDRESS OF SERVER             
SOCKADRL DC    F'8'                                                             
         DROP     ,                                                             
*                                                                               
*                                                                               
* * THE PROGRAM MAINLINE LOGIC STARTS HERE...                                   
* * WE SHOULD BE ENTERED IN 31-BIT MODE AND WILL GO INTO 24-BIT                 
* * MODE ONLY WHEN USING A SERVICE THAT REQUIRES 24-BIT MODE...                 
MAIN1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R12,R15             SET 1ST BASE REGISTER                        
         LA    R9,2048(,R12)       SET 2ND BASE REG                             
         LA    R9,2048(,R9)        "                                            
         USING BSDCLINT,R12,R9     ESTABLISH BASE REGISTERS                     
         ST    R13,MAINSAVE+4      STORE CALLERS R13                            
         LA    R13,MAINSAVE        PROVIDE SAVEAREA                             
         AMODESW SET,AMODE=24      SWITCH TO 24 BIT MODE FOR OPENS              
         OPEN  CONSOLE,LISTING,CARDIN                                           
         AMODESW SET,AMODE=31      SWITCH BACK TO 31-BIT MODE                   
*                                                                               
* * BSD-C SOCKET() CALL INVOKES IPNRSOCK...                                     
         LA    R1,DOMAIN           @ OF DOMAIN                                  
         ST    R1,PARM1            STORE IT                                     
         LA    R1,TYPE             @ OF TYPE                                    
         ST    R1,PARM2            STORE IT                                     
         LA    R1,PROTOCOL         @ OF PROTOCOL                                
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRSOCK)    @ SOCKET FUNCTION ROUTINE                    
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID WE GET A SOCKET NUMBER ?                 
         BNM   MAIN1200            BIF YES                                      
         BAL   R1,MAIN7000         BSDC FUNCTION FAILED                         
         DC    C'IPNRSOCK'                                                      
MAIN1200 DS    0H                                                               
         ST    R15,BASESOCK        STORE THE SOCKET NUMBER                      
*                                                                               
* * BSD-C CONNECT() CALL INVOKES IPNRCONN...                                    
* * THIS WILL CAUSE A ACTIVE OPEN TO BE ISSUED...                               
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         LA    R1,SOCKADDR         @ MAXIMUM CONNECTIONS                        
         ST    R1,PARM2            STORE IT                                     
         LA    R1,SOCKADRL         @ MAXIMUM CONNECTIONS                        
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRCONN)    @ CONNECT FUNCTION ROUTINE                   
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID WE GET CONNECTED ?                       
         BNM   MAIN1400            BIF YES                                      
         BAL   R1,MAIN7000         BSDC FUNCTION FAILED                         
         DC    C'IPNRCONN'                                                      
MAIN1400 DS    0H                                                               
         AMODESW SET,AMODE=24                                                   
         GET   CARDIN              GET A COMMAND FROM SYSIPT                    
         AMODESW SET,AMODE=31                                                   
         LA    R0,L'CARDAREA                                                    
         LA    R1,CARDAREA                                                      
         L     R15,@CONORTN        ECHO THE CARD ONTO SYSLOG + SYSLST           
         BASSM R14,R15                                                          
         MVC   SNDBUFF,CARDAREA    MOVE COMMAND INTO THE SEND BUFFER            
         MVI   SNDBUFF+72,X'15'    END OF COMMAND                               
*                                                                               
* * BSD-C SEND FUNCTION CALL...                                                 
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         LA    R1,SNDBUFF          @ OF DATA TO SEND                            
         ST    R1,PARM2            STORE IT                                     
         LA    R1,SNDBUFFL         @ OF SEND LENGTH                             
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRSEND)    @ SEND FUNCTION ROUTINE                      
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE DATA GET SENT ?                      
         BNM   MAIN2000            BIF YES                                      
         DC    H'0'                NEVER SHOULD OCCURR...                       
MAIN2000 DS    0H                                                               
         LA    R0,L'REPLY          MAXIMUM REPLY AREA                           
         LA    R1,REPLY            BUILD THE REPLY HERE                         
         L     R15,@RSTREAM        @ OF THE STREAM READ ROUTINE                 
         BASSM R14,R15                                                          
         LTR   R15,R15             DID WE GET A REPLY ?                         
         BZ    MAIN4000            BIF YES                                      
         BAL   R1,MAIN7000         ERROR EXIT                                   
         DC    C'BADREPLY'                                                      
MAIN4000 DS    0H                                                               
         L     R15,@CONORTN        ECHO THE REPLY ONTO SYSLOG + SYSLST          
         BASSM R14,R15                                                          
         B     MAIN1400            GET THE NEXT CARD...                         
*                                                                               
* * ALL OUT OF CARDS SO LETS CLOSE THE CONNECTION...                            
MAIN6000 DS    0H                                                               
         AMODESW SET,AMODE=31                                                   
*                                                                               
* * BSD-C CLOSE FUNCTION CALL...                                                
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRCLOS)    @ CLOSE FUNCTION ROUTINE                     
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE SOCKET GET CLOSED ?                  
         BNM   TASK6200            BIF YES                                      
         LA    R0,L'CLOSTERM                                                    
         LA    R1,CLOSTERM                                                      
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     TASK6200            IGNORE THE ERROR                             
CLOSTERM DC    C'CLOSE TERMINATED'                                              
TASK6200 DS    0H                                                               
         LA    R15,0               RETURN CODE IS ZERO                          
         ST    R15,RETCODE         STORE THE RETURN CODE                        
         B     MAIN9000            ALL DONE                                     
*                                                                               
MAIN7000 DS    0H                                                               
         LTR   R15,R15             WAS A RETURN CODE PASSED                     
         BNZ   MAIN7200            BIF YES                                      
         LA    R15,8               SET BAD RETURN CODE                          
MAIN7200 DS    0H                                                               
         ST    R15,RETCODE         STORE IT                                     
         MVC   IERRRESN,0(R1)      ERROR MESSAGE REASON                         
         LA    R0,IERRMSGL         ERROR MESSAGE LENGTH                         
         LA    R1,IERRMSG          ERROR MESSAGE TEXT                           
         L     R15,@CONORTN                                                     
         BASSM R14,R15             WRITE ERROR REASON                           
         B     MAIN9000            EXIT                                         
*                                                                               
MAIN9000 DS    0H                                                               
*                                                                               
* * THE FOLLOWING IS THE SAME AS DOING AN EOJ MACRO...                          
         L     R15,RETCODE         RETURN CODE                                  
         L     R13,MAINSAVE+4      RESTORE JOB CONTROLS R13                     
         LM    R0,R12,20(R13)      RESTORE R0-R12                               
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
*                                                                               
* *                                                                             
TRACEIT  DS    0H                                                               
         LA    R0,8                                                             
         LTR   R1,R2               @ OF TRACE INFO                              
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     8(R2)               RETURN                                       
*                                                                               
MAINSAVE DS    9D                                                               
DWORK    DS    D                                                                
FWORK    DS    F                                                                
@CONORTN DC    A(CONO1000)         CONSOLE OUTPUT ROUTINE                       
@PUTLRTN DC    A(PUTL1000)                                                      
@RSTREAM DC    A(RSTR1000)         TCP STREAM PROCESSOR                         
RECBUFFL DC    F'80'                                                            
@RECBUFF DC    A(RECBUFF)                                                       
SNDBUFFL DC    F'80'                                                            
@SNDBUFF DC    A(SNDBUFF)                                                       
SERVIPAD DC    AL1(192),AL1(168),AL1(3),AL1(1)                                  
SERVPORT DC    H'6200'             PORT OF BSDSERVR                             
RETCODE  DC    F'99'                                                            
SNDBUFF  DS    CL80                                                             
RECBUFF  DS    CL80                                                             
REPLY    DS    CL80                                                             
HEXWORK  DS    XL9                 HEX WORK AREA                                
*                                                                               
IERRMSG  DS    0H                                                               
         DC    C'Critical Error Occurred Reason='                               
IERRRESN DC    CL8'XXXXXXXX'                                                    
IERRMSGL EQU   *-IERRMSG                                                        
*                                                                               
LISTING  DTFDI DEVADDR=SYSLST,             DEFINE A PRINTER            *        
               IOAREA1=LINEOUT,            OUTPUT LINE                 *        
               RECSIZE=121                 LENGTH OF RECORD                     
LINEOUT  DS    CL121                                                            
*                                                                               
CARDIN   DTFDI IOAREA1=CARDAREA,                                       *        
               DEVADDR=SYSRDR,                                         *        
               RECSIZE=80,                                             *        
               EOFADDR=MAIN6000                                                 
CARDAREA DS    CL80                                                             
*                                                                               
CONSOLE  DTFCN DEVADDR=SYSLOG,             CONSOLE DEVICE ADDRESS      *        
               IOAREA1=CONOUT,             I/O AREA BUFFERS OUT+IN     *        
               RECFORM=FIXUNB,             FIXED UNBLOCKED             *        
               BLKSIZE=64,                 OUTPUT AREA SIZE            *        
               INPSIZE=64,                 INPUT AREA SIZE             *        
               TYPEFLE=CMBND               COMBINED INPUT/OUTPUT                
CONOUT   DS    CL64                        OUTPUT BUFFER AREA                   
*                                                                               
         LTORG ,                                                                
*                                                                               
* * THE FOLLOWING ROUNDS OFF TO 8K                                              
BIGWORK  DS    XL((8192)-(*-BSDCLINT))                                          
BIGWORKL EQU   *-BIGWORK                                                        
         DROP  ,                                                                
*                                                                               
* * GET A REPLY BY READING TCP STREAM...                                        
* * R0 = REPLY LENGTH                                                           
* * R1 = REPLY TEXT                                                             
         USING BSDCLINT,R12,R9     ESTABLISH BSDCLINT ADDRESSABILITY            
         DC    CL8'RSTR1000'                                                    
RSTR1000 DS    0H                                                               
*                                                                               
* It is fundamentally important to understand the concept of streams            
* when programming with TCP.                                                    
* TCP may choose to break a block of data into pieces and transmit              
* each piece in a separate segement or it may choose to accumulate              
* data in its buffer before sending a segment(fully fill a datagram)            
* As a result the receiving application may receive data in small               
* chunks, even if the sending application passed it to TCP in a                 
* single send.                                                                  
* Or, the receiving application may receive a large chunk                       
* even if the sending application passes it to TCP in multiple send             
* requests.                                                                     
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING RSTR1000,R11                                                     
         ST    R13,RSTRSAVE+4                                                   
         LA    R13,RSTRSAVE                                                     
         LTR   R5,R1               BUILD RELPLY FROM STREAM HERE                
         LTR   R6,R0               MAX THAT CAN FIT IN A COMMAND                
         ST    R5,RSTRCADR         STORE PASSED ADDRESS OF AREA TO FILL         
         ST    R6,RSTRCLNG         STORE PASSED LENGTH                          
*                                                                               
* * GET A TELNET RECORD FOR THE CALLER                                          
* * RECORD MEANS GET A STREAM AND SCAN UNTIL WE GET A END OF LINE...            
         ICM   R3,15,RSTRWADR      DO WE HAVE A STREAM POINTER?                 
         BZ    RSTR1800            BIF NO GET SOME DATA                         
         L     R1,@RECBUFF         START OF STREAM                              
         L     R2,RSTRWLNG         LENGTH OF STREAM                             
         LA    R4,0(R2,R1)         END OF STREAM                                
         SLR   R4,R3               CALCULATE LENGTH LEFT                        
         B     RSTR3400            PICK UP HERE...                              
RSTR1800 DS    0H                                                               
*                                                                               
* * BSD-C RECV FUNCTION CALL...                                                 
         LA    R1,BASESOCK         @ OF SOCKET NUMBER                           
         ST    R1,PARM1            STORE IT                                     
         L     R1,@RECBUFF         @ OF AREA TO RECEIVE THE DATA                
         ST    R1,PARM2            STORE IT                                     
         LA    R1,RECBUFFL         @ OF RECEIVE AREA LENGTH                     
         ST    R1,PARM3            STORE IT                                     
         LA    R1,PARMS            @ OF PARAMTERS TO BE PASSED                  
         L     R15,=V(IPNRRECV)    @ RECEIVE FUNCTION ROUTINE                   
         BALR  R14,R15             GO FOR IT                                    
         LTR   R15,R15             DID THE RECEIVE WORK ?                       
         BM    RSTR9000            BIF NO                                       
         LTR   R4,R15              DID WE GET ANY?                              
         BP    RSTR3000            BIF YES                                      
         DC    H'0'                NEVER SHOULD OCCURR...                       
RSTR3000 DS    0H                                                               
         ST    R4,RSTRWLNG         STORE THE LENGTH RECEIVED                    
         L     R3,@RECBUFF         START ADDRESS OF DATA RECEIVED               
         ST    R3,RSTRWADR         STORE THE NEW POINTER                        
RSTR3400 DS    0H                                                               
         CLI   0(R3),X'15'         IS THIS A EBCIDIC NEW LINE ?                 
         BE    RSTR7000            BIF YES                                      
         MVC   0(1,R5),0(R3)       MOVE A BYTE INTO BUFFER                      
         LA    R3,1(,R3)           BUMP TO NEXT IN STREAM                       
         LA    R5,1(,R5)           BUMP TO NEXT IN COMMAND                      
         BCT   R4,RSTR4000         IF NOT ZERO GOTO RSTR4000                    
         B     RSTR1800            DO A RECEIVE FOR MORE OF STREAM              
*                                                                               
* *                                                                             
RSTR4000 DS    0H                                                               
         BCT   R6,RSTR3400         DO IT AGAIN                                  
*                                                                               
* * IF WE FALL THRU THE ABOVE BCT THAN WE HAVE SCANNED FOR 80                   
* * BYTES AND HAVE NOT HIT A END OF LINE CHARACTER...                           
         BAL   R1,RSTR9000                                                      
         DC    CL8'REPNOEOL'                                                    
RSTR7000 DS    0H                                                               
         LA    R3,1(,R3)           BUMP PAST END OF LINE                        
         BCT   R4,RSTR8000                                                      
         SLR   R3,R3               NO MORE DATA IN STREAM                       
RSTR8000 DS    0H                                                               
         ST    R3,RSTRWADR         STORE UPDATED POINTER INTO STREAM            
         L     R1,RSTRCADR         R1 = ADDRESS OF THE COMMAND                  
         LR    R0,R5               R0 = RECORD LENGTH                           
         SR    R0,R1               CALCULATE THE RECORD LENGTH                  
         LA    R15,0               RC = GOOD                                    
RSTR9000 DS    0H                                                               
         L     R13,RSTRSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BR    R14                 RETURN TO CALLER                             
         LTORG ,                                                                
RSTRSAVE DS    9D                                                               
RSTRCLNG DS    F                                                                
RSTRCADR DS    F                                                                
RSTRWLNG DS    F                                                                
RSTRWADR DS    F                                                                
         DROP  ,                                                                
*                                                                               
* * R0 = MESSAGE LENGTH                                                         
* * R1 = MESSAGE TEXT                                                           
         USING BSDCLINT,R12,R9     ESTABLISH BSDCLINT ADDRESSABILITY            
         DC    CL8'PUTL1000'                                                    
PUTL1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15             GET A BASE REGISTER                          
         USING PUTL1000,R11                                                     
         ST    R13,PUTLSAVE+4      STORE CALLERS R13                            
         LA    R13,PUTLSAVE        PROVIDE SAVEAREA                             
         LR    R4,R0               MESSAGE LENGTH                               
         LR    R5,R1               MESSAGE TEXT                                 
         MVI   LINEOUT,X'40'       CLEAR I/O AREA                               
         MVC   LINEOUT+1(L'LINEOUT-1),LINEOUT PROPOGATE THE BLANK               
         LR    R2,R4               MESSAGE LENGTH                               
         BCTR  R2,0                MINUS 1 FOR THE EXECUTE                      
         EX    R2,PUTLMVC                                                       
         AMODESW SET,AMODE=24                                                   
         PUT   LISTING                                                          
         AMODESW SET,AMODE=31                                                   
PUTL9000 DS    0H                                                               
         LA    R15,0               RETURN CODE                                  
         L     R13,PUTLSAVE+4      RESTORE CALLERS R13                          
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
PUTLMVC  MVC   LINEOUT+1(0),0(R5)  EXECUTED INSTRUCTION                         
PUTLSAVE DS    18F                                                              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
* * R0 = MESSAGE LENGTH                                                         
* * R1 = MESSAGE TEXT                                                           
         USING BSDCLINT,R12,R9     ESTABLISH BSDCLINT ADDRESSABILITY            
         DC    CL8'CONO1000'                                                    
CONO1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15             GET A BASE REGISTER                          
         USING CONO1000,R11                                                     
         LR    R4,R0               MESSAGE LENGTH                               
         LR    R5,R1               MESSAGE TEXT                                 
         ST    R13,CONOSAVE+4      STORE CALLERS R13                            
         LA    R13,CONOSAVE        PROVIDE SAVEAREA                             
         MVI   CONOUT,X'40'        CLEAR I/O AREA                               
         MVC   CONOUT+1(L'CONOUT-1),CONOUT PROPOGATE THE BLANK                  
         LTR   R2,R4               IS THE MESSAGE LENGTH ZERO                   
         BNZ   CONO2000            PUT OUT INVALID MESSAGE MESSAGE              
         LA    R0,L'CONOBAD1                                                    
         LA    R1,CONOBAD1         PUT OUT THIS MESSAGE                         
CONO2000 DS    0H                                                               
         LA    R0,L'CONOUT                                                      
         CLR   R2,R0               IS IT TOO BIG                                
         BL    CONO3000            BIF NO                                       
         LR    R2,R0               USE THE MAX                                  
CONO3000 DS    0H                                                               
         BCTR  R2,0                MINUS 1 FOR THE EXECUTE                      
         EX    R2,CONOMVC                                                       
         AMODESW SET,AMODE=24                                                   
         PUT   CONSOLE                                                          
         WAIT  CONSOLE                                                          
         AMODESW SET,AMODE=31                                                   
         LA    R0,L'CONOUT                                                      
         LA    R1,CONOUT                                                        
         L     R15,@PUTLRTN        DISPLAY ONTO SYSLST TOO                      
         BASSM R14,R15                                                          
CONO9000 DS    0H                                                               
         LA    R15,0               RETURN CODE                                  
         L     R13,CONOSAVE+4      RESTORE CALLERS R13                          
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CONOMVC  MVC   CONOUT(0),0(R5)     EXECUTED INSTRUCTION                         
CONOBAD1 DC    C'CONOBAD1'                                                      
CONOSAVE DS    18F                                                              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
*                                                                               
* * EQUATES...                                                                  
R0       EQU      0                                                             
R1       EQU      1                                                             
R2       EQU      2                                                             
R3       EQU      3                                                             
R4       EQU      4                                                             
R5       EQU      5                                                             
R6       EQU      6                                                             
R7       EQU      7                                                             
R8       EQU      8                                                             
R9       EQU      9                                                             
R10      EQU      10                                                            
R11      EQU      11                                                            
R12      EQU      12                                                            
R13      EQU      13                                                            
R14      EQU      14                                                            
R15      EQU      15                                                            
         END   BSDCLINT                                                         
/*                                                                              
*                                                                               
* * EXECUTING LINK EDIT TO CREATE BSDCLINT PHASE...                             
// EXEC LNKEDT,SIZE=512K                                                        
/*                                                                              
*                                                                               
* * EXECUTING SAMPLE BSD CLIENT...                                              
// LIBDEF PHASE,SEARCH=DRSLIB.TEST                                              
// EXEC BSDCLINT,SIZE=BSDCLINT  TRACE                                           
HARTBEAT                                                                        
/*                                                                              
/&                                                                              
* $$ EOJ                                                                        
